# SymplecticMatrices

[![Build status (Github Actions)](https://github.com/apkille/SymplecticMatrices.jl/workflows/CI/badge.svg)](https://github.com/apkille/SymplecticMatrices.jl/actions)
![codecov](https://codecov.io/github/apkille/SymplecticMatrices.jl/graph/badge.svg?token=JWMOD4FY6P)
[![JET static analysis](https://img.shields.io/badge/%F0%9F%9B%A9%EF%B8%8F_tested_with-JET.jl-233f9a)](https://github.com/aviatesk/JET.jl)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)

SymplecticMatrices is a Julia package for performing optimized linear algebra computations and special decompositions of symplectic matrices. A symplectic matrix `S` is a `2n x 2n` matrix
that satisfies the condition `SJSᵀ = J`, where `J` is a `2n x 2n` invertible, skew-symmetric matrix called the symplectic form.

The full API can be found at the documentation page: [![](https://img.shields.io/badge/docs-stable-blue.svg)](https://apkille.github.io/SymplecticMatrices.jl/)

## Usage

To install SymplecticMatrices.jl, start Julia and run the following command:

```julia
] add SymplecticMatrices
```

## `Symplectic` matrix type

The `Symplectic` matrix type is simply a wrapper around a matrix and its corresponding symplectic form.
To give a taste, compute a random symplectic matrix `S` by specifying the symplectic form type:

```julia
julia> using SymplecticMatrices

julia> J = BlockForm(2)
BlockForm(2)

julia> symplecticform(J)
4×4 Matrix{Float64}:
  0.0   0.0  1.0  0.0
  0.0   0.0  0.0  1.0
 -1.0   0.0  0.0  0.0
  0.0  -1.0  0.0  0.0

julia> S = randsymplectic(Symplectic, J)
4×4 Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}:
 -0.116535    -0.181523  1.15808    0.00240053
  0.137176    -0.498848  0.55193   -1.22289
 -0.853172    -0.578052  0.452435  -0.348686
  0.00544036   0.618131  0.493416  -0.35965

julia> issymplectic(S, atol=1e-10)
true
```
Similar methods exist for `PairForm(n)`, which corresponds to the symplectic form equal to the direct
sum of `[0 1; -1 0]`. The matrix type `Symplectic` is nice for keeping track of the symplectic basis
and performing optimized computations, however, standard Julia matrix types are supported in this package:

```julia
julia> s = randsymplectic(J)
4×4 Matrix{Float64}:
 -7.69543  -41.5856  13.5169    92.976
 -2.04414   -8.3759   5.14638   18.4387
  5.89402   33.3788  -9.05499  -74.8917
 -6.10599  -30.7716   9.99773   68.9329

julia> issymplectic(J, s, atol=1e-10)
true

julia> issymplectic(PairForm(2), s, atol=1e-10)
false
```
In the last line of code, the symplectic check failed because we defined `s` with respect to `BlockForm` rather than `PairForm`.

Other symplectic matrix types include `SymplecticHouseholder`, `SymplecticGivens`, and `SymplecticGauss`, which
can be created with the `householder`, `givens`, and `gauss` functions.

## Symplectic decompositions

To compute the symplectic polar decomposition of `S`, which produces a product of an orthosymplectic matrix `O` and positive-definite symmetric symplectic matrix `P`, call `polar`:

### Polar Decomposition

```julia
julia> F = polar(S)
Polar{Float64, Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}, Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}}
O factor:
4×4 Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}:
  0.123739  -0.181484  0.923535   0.314381
  0.316785  -0.36622   0.177255  -0.856803
 -0.923535  -0.314381  0.123739  -0.181484
 -0.177255   0.856803  0.316785  -0.36622
P factor:
4×4 Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}:
  0.816005     0.243795  -0.187156  -0.00132403
  0.243795     0.926977  -0.131778   0.248883
 -0.187156    -0.131778   1.37965   -0.371624
 -0.00132403   0.248883  -0.371624   1.24352

julia> isapprox(F.O * F.P, S, atol = 1e-10)
true
```

### Williamson Decomposition

To compute the Williamson decomposition of a positive definite matrix `V`, which finds a congruence relation between a symplectic matrix `S` and a diagonal matrix containing the symplectic eigenvalues `spectrum`, call `williamson`:

```julia
julia> X = rand(4, 4); V = X' * X
4×4 Matrix{Float64}:
 1.39837   1.01419   0.819762  0.644317
 1.01419   1.0662    0.452062  0.525889
 0.819762  0.452062  1.1312    1.02089
 0.644317  0.525889  1.02089   1.09805

julia> F = williamson(Symplectic, J, V)
Williamson{Float64, Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}, Vector{Float64}}
S factor:
4×4 Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}:
 -0.67512    0.66685    0.586     -0.437417
  0.733677   0.731394  -0.305086  -0.143899
  0.686747  -0.647894  -1.33318    1.17835
 -0.24263   -0.213864   0.785636   0.722449
symplectic spectrum:
2-element Vector{Float64}:
 0.05191288411625232
 1.8137043652121851

julia> isapprox(F.S * V * F.S', Diagonal(repeat(F.spectrum, 2)), atol = 1e-10)
true
```

### Bloch-Messiah Decomposition

To compute the Bloch-Messiah/Euler decomposition of a symplectic matrix `S`, which finds the product of an orthosymplectic matrix followed by a diagonal matrix followed by another orthosymplectic matrix, call `blochmessiah`:

```julia
julia> F = blochmessiah(S)
BlochMessiah{Float64, Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}, Vector{Float64}}
O factor:
4×4 Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}:
 -0.636034   -0.492216   0.331745    0.493082
  0.696422   -0.690058   0.0200433   0.195995
 -0.331745   -0.493081  -0.636034   -0.492216
 -0.0200437  -0.195995   0.696422   -0.690058
values:
2-element Vector{Float64}:
 1.0016241730101116
 1.8152715263879216
Q factor:
4×4 Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}:
 0.451846  -0.0524922  -0.511355  -0.729107
 0.210612   0.329129   -0.699996   0.597764
 0.511355   0.729107    0.451845  -0.0524917
 0.699996  -0.597764    0.210612   0.32913

julia> D = Diagonal(vcat(F.values, F.values .^ (-1))) # sort singular values in direct sum form
4×4 Diagonal{Float64, Vector{Float64}}:
 1.00162   ⋅        ⋅         ⋅ 
  ⋅       1.81527   ⋅         ⋅ 
  ⋅        ⋅       0.998378   ⋅ 
  ⋅        ⋅        ⋅        0.550882

julia> F.O * D * F.Q # == S
4×4 Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}:
 -0.116535    -0.181523  1.15808    0.0024005
  0.137176    -0.498848  0.55193   -1.22289
 -0.853173    -0.578053  0.452434  -0.348686
  0.00544102   0.618132  0.493417  -0.35965
```

## Quick Benchmarks

### 

<details>
  <summary>Matrix Inverse</summary>
<p>

```julia
julia> S = randsymplectic(Symplectic, BlockForm(100));

julia> @btime inv($S.data);
  650.084 μs (9 allocations: 414.30 KiB)

julia> @btime inv($S);
  279.875 μs (12 allocations: 1.22 MiB)
```

</p>
</details>


<details>
  <summary>Symplectic Decompositions</summary>
<p>

```julia
julia> @btime polar(S) setup=(S=randsymplectic(Symplectic, BlockForm(100)));
  6.826 ms (29 allocations: 3.08 MiB)

julia> @btime williamson(J, V) setup=(X=rand(200,200); V=X'*X; J=BlockForm(100));
  22.587 ms (129 allocations: 6.77 MiB)

julia> @btime blochmessiah(S) setup=(S=randsymplectic(Symplectic, BlockForm(100)));
  11.867 ms (64 allocations: 4.68 MiB)
```
<p>
</details>

<details>
  <summary>Version Information</summary>
<p>

```julia
julia> versioninfo()
Julia Version 1.11.1
Commit 8f5b7ca12ad (2024-10-16 10:53 UTC)
Build Info:
  Official https://julialang.org/ release
Platform Info:
  OS: macOS (arm64-apple-darwin22.4.0)
  CPU: 8 × Apple M1 Pro
  WORD_SIZE: 64
  LLVM: libLLVM-16.0.6 (ORCJIT, apple-m1)
Threads: 1 default, 0 interactive, 1 GC (on 6 virtual cores)
```
<p>
</details>

struct Takagi{T,M<:AbstractArray{T},N<:AbstractVector{<:Real}} <: Factorization{T}
    Q::M
    S::N
    function Takagi{T,M,N}(Q, S) where {T,M<:AbstractArray{T},N<:AbstractVector{<:Real}}
        require_one_based_indexing(Q, S)
        new{T,M,N}(Q, S)
    end
end
Takagi{T}(Q::AbstractArray{T}, S::AbstractVector{<:Real}) where {T} = Takagi{T,typeof(Q),typeof(S)}(Q,S)

# iteration for destructuring into components
Base.iterate(F::Takagi) = (F.Q, Val(:S))
Base.iterate(F::Takagi, ::Val{:S}) = (F.S, Val(:done))
Base.iterate(F::Takagi, ::Val{:done}) = nothing

function takagi(x::AbstractMatrix{T}) where {T<:Union{Real,Complex}}
    fact = svd(Symmetric(x))
    Tt = T <: Complex ? T : ComplexF64
    Q = zeros(Tt, size(x))
    mul!(Q, fact.U, sqrt(conj(transpose(fact.U) * fact.V)))
    return Takagi{Tt}(Q, fact.S)
end
function Base.show(io::IO, mime::MIME{Symbol("text/plain")}, F::Takagi{<:Any,<:AbstractArray,<:AbstractVector})
    Base.summary(io, F); println(io)
    println(io, "Q factor:")
    Base.show(io, mime, F.Q)
    println(io, "\nsingular values:")
    Base.show(io, mime, F.S)
end

"""
    Polar <: Factorization

Matrix factorization type of the polar decomposition of a symplectic matrix `S`.
This is the return type of [`polar(_)`](@ref), the corresponding matrix factorization function.

If `F::Polar` is the factorization object, `O` and `P` can be obtained
via `F.O` and `F.P`, such that `S = O * P`.

Iterating the decomposition produces the components `O` and `P`.

# Examples
```jldoctest
julia> S = [1. 1.; 0. 1.]
2×2 Matrix{Float64}:
 1.0  1.0
 0.0  1.0

julia> issymplectic(BlockForm(1), S)
true

julia> F = polar(S)
Polar{Float64, Matrix{Float64}, Matrix{Float64}}
O factor:
2×2 Matrix{Float64}:
  0.894427  0.447214
 -0.447214  0.894427
P factor:
2×2 Matrix{Float64}:
 0.894427  0.447214
 0.447214  1.34164

julia> isapprox(F.O * F.P, S)
true

julia> O, P = F; # destructuring via iteration

julia> O == F.O && P == F.P
true
```
"""
struct Polar{T,M<:AbstractArray{T},N<:AbstractArray{T}} <: Factorization{T}
    O::M
    P::N
    function Polar{T,M,N}(O, P) where {T,M<:AbstractArray{T},N<:AbstractArray{T}}
        require_one_based_indexing(O, P)
        new{T,M,N}(O, P)
    end
end
Polar{T}(O::AbstractArray{T}, P::AbstractArray{T}) where {T} = Polar{T,typeof(O),typeof(P)}(O,P)

# iteration for destructuring into components
Base.iterate(F::Polar) = (F.O, Val(:P))
Base.iterate(F::Polar, ::Val{:P}) = (F.P, Val(:done))
Base.iterate(F::Polar, ::Val{:done}) = nothing

"""
    polar(S::AbstractMatrix) -> Polar
    polar(S::Symplectic) -> Polar

Compute the polar decomposition of a symplectic matrix `S` and return a `Polar` object.

`O` and `P` can be obtained from the factorization `F` via `F.O` and `F.P`, such that `S = O * P`.
For the symplectic polar decomposition case, `O` is an orthogonal symplectic matrix and `P` is a positive-definite
symmetric symplectic matrix.

Iterating the decomposition produces the components `O` and `P`.

# Examples
```jldoctest
julia> S = [1. 1.; 0. 1.]
2×2 Matrix{Float64}:
 1.0  1.0
 0.0  1.0

julia> issymplectic(BlockForm(1), S)
true

julia> F = polar(S)
Polar{Float64, Matrix{Float64}, Matrix{Float64}}
O factor:
2×2 Matrix{Float64}:
  0.894427  0.447214
 -0.447214  0.894427
P factor:
2×2 Matrix{Float64}:
 0.894427  0.447214
 0.447214  1.34164

julia> isapprox(F.O * F.P, S)
true

julia> O, P = F; # destructuring via iteration

julia> O == F.O && P == F.P
true
```
"""
function polar(x::AbstractMatrix{T}) where {T}
    O, P = _polar(x)
    return Polar{T}(O, P)
end
function polar(x::Symplectic{F,T,D}) where {F<:SymplecticForm,T,D<:AbstractMatrix{T}} 
    O, P = _polar(x.data)
    return Polar{T}(Symplectic(x.form, O), Symplectic(x.form, P))
end
function _polar(x::AbstractMatrix{T}) where {T}
    fact = svd(x)
    dims = size(x)
    O, P = zeros(T, dims), zeros(T, dims)
    mul!(O, fact.U, fact.Vt)
    copyto!(P, fact.V * Diagonal(fact.S) * fact.Vt)
    return O, P
end

function Base.show(io::IO, mime::MIME{Symbol("text/plain")}, F::Polar{<:Any,<:AbstractArray,<:AbstractArray})
    Base.summary(io, F); println(io)
    println(io, "O factor:")
    Base.show(io, mime, F.O)
    println(io, "\nP factor:")
    Base.show(io, mime, F.P)
end

@testitem "gauss" begin
    using SymplecticMatrices
    using LinearAlgebra: I, adjoint, inv, lmul!, rmul!

    @testset "predefined gauss transformations" begin
        k, n = 2, 4
        c, d = 2.0, 3.0
        G_block, G_pair = gauss(BlockForm(n), k, c, d), gauss(PairForm(n), k, c, d)
        M_block = [2.0 0.0 0.0 0.0 0.0 3.0 0.0 0.0;
                   0.0 2.0 0.0 0.0 3.0 0.0 0.0 0.0;
                   0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0;
                   0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0;
                   0.0 0.0 0.0 0.0 0.5 0.0 0.0 0.0;
                   0.0 0.0 0.0 0.0 0.0 0.5 0.0 0.0;
                   0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0;
                   0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0]
        M_pair =  [2.0 0.0 0.0 3.0 0.0 0.0 0.0 0.0;
                   0.0 0.5 0.0 0.0 0.0 0.0 0.0 0.0;
                   0.0 3.0 2.0 0.0 0.0 0.0 0.0 0.0;
                   0.0 0.0 0.0 0.5 0.0 0.0 0.0 0.0;
                   0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0;
                   0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0;
                   0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0;
                   0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0]
        @test M_block ≈ Matrix(G_block) && M_pair ≈ Matrix(G_pair)
        @test M_block ≈ Array(G_block) && M_pair ≈ Array(G_pair)
        @test AbstractMatrix{Float32}(M_block) ≈ AbstractMatrix{Float32}(G_block) && AbstractMatrix{Float32}(M_pair) ≈ AbstractMatrix{Float32}(G_pair)

        @test G_block[1,1] == G_block[2,2] == 2.0
        @test G_block[1,6] == G_block[2,5] == 3.0
        @test G_block[5,5] == G_block[6,6] == 0.5
        @test G_block[3,3] == G_block[4,4] == G_block[7,7] == G_block[8,8] == 1.0
        @test G_block[1,2] == G_block[2,1] == G_block[1,8] == G_block[8,1] == 0.0

        @test G_pair[1,1] == G_pair[3,3] == 2.0
        @test G_pair[1,4] == G_pair[3,2] == 3.0
        @test G_pair[2,2] == G_pair[4,4] == 0.5
        @test G_pair[5,5] == G_pair[6,6] == G_pair[7,7] == G_pair[8,8] == 1.0
        @test G_pair[1,2] == G_pair[2,1] == G_pair[7,8] == G_pair[8,7] == 0.0
        @test G_pair[2,3] == G_pair[3,4] == 0.0

        @test G_block[1]  == G_block[10] == 2.0
        @test G_block[41] == G_block[34] == 3.0
        @test G_block[37] == G_block[46] == 0.5
        @test G_block[19] == G_block[28] == G_block[55] == G_block[64] == 1.0
        @test G_block[2]  == G_block[9]  == G_block[8]  == G_block[61] == 0.0

        @test G_pair[1]   == G_pair[19] == 2.0
        @test G_pair[25]  == G_pair[11] == 3.0
        @test G_pair[10]  == G_pair[28] == 0.5
        @test G_pair[37]  == G_pair[46] == G_pair[55] == G_pair[64] == 1.0
        @test G_pair[2]   == G_pair[9]  == G_pair[17] == 0.0
    end

    @testset "base methods" begin
        n = rand(3:5)
        k = rand(3:5)
        n = 2 * n
        c, d = rand(), rand()
        J, Omega = BlockForm(n), PairForm(n)
        M = rand(Float64, 2n, 2n)

        @inbounds for form in [J, Omega]
            G = gauss(form, k, c, d)
            Gnew = gauss(form, k-1, rand(), rand())
            @test isequal(G, copy(G)) && isapprox(G, copy(G))
            @test copy(G) ≈ G
            @test size(G) == (2n, 2n) && size(G, 1) == size(G, 2) == 2n
            @test length(G) == 4n^2
            @test axes(G) == (1:2n, 1:2n)
            @test eltype(G) == Float64

            GMat = Matrix(G)
            GMatnew = Matrix(Gnew)
            i, j = rand(1:2n), rand(1:2n)
            ind = rand(1:4n^2)
            @test G[i,j] ≈ GMat[i,j] && G[j,i] ≈ GMat[j,i]
            @test G[i] ≈ GMat[i] && G[j] ≈ GMat[j] && G[ind] ≈ GMat[ind]

            Z = zeros(Float64, 2n, 2n)
            SZ = Symplectic(form, copy(Z))
            copyto!(Z, G)
            copyto!(SZ, G)
            @test isapprox(Z, GMat, atol = 1e-8) && isapprox(SZ, Symplectic(form, GMat), atol = 1e-8)
            @test isapprox(G * M, GMat * M, atol = 1e-6) && isapprox(M * G, M * GMat, atol = 1e-8)
            @test isapprox(Matrix(G * G), GMat * GMat, atol = 1e-8) && isapprox(Symplectic(form, Matrix(Gnew * G)), Symplectic(form, GMatnew * GMat), atol = 1e-8)
            @test isapprox(G * Symplectic(form, M), Symplectic(form, GMat * M), atol = 1e-8) && isapprox(Symplectic(form, M) * G, Symplectic(form, M * GMat), atol = 1e-8)
            @test isapprox(G / M, GMat / M, atol = 1e-8) && isapprox(M / G, M / GMat, atol = 1e-8)
            @test isapprox(Matrix(G / G), GMat / GMat, atol = 1e-8) && isapprox(Symplectic(form, Matrix(Gnew / G)), Symplectic(form, GMatnew / GMat), atol = 1e-8)
            @test isapprox(G / Symplectic(form, M), Symplectic(form, GMat / M), atol = 1e-8) && isapprox(Symplectic(form, M) / G, Symplectic(form, M / GMat), atol = 1e-8)
            @test isapprox(G \ M, GMat \ M, atol = 1e-8) && isapprox(M \ G, M \ GMat, atol = 1e-8)
            @test isapprox(Matrix(G \ G), GMat \ GMat, atol = 1e-8) && isapprox(Symplectic(form, Matrix(Gnew \ G)), Symplectic(form, GMatnew \ GMat), atol = 1e-8)
            @test isapprox(G \ Symplectic(form, M), Symplectic(form, GMat \ M), atol = 1e-8) && isapprox(Symplectic(form, M) \ G, Symplectic(form, M \ GMat), atol = 1e-8)
        end
    end

    @testset "LinearAlgebra methods" begin
        n = rand(3:5)
        k = rand(2:n)
        n = 2 * n
        c, d = rand(), rand()
        J, Omega = BlockForm(n), PairForm(n)

        @inbounds for form in [J, Omega]
            G = gauss(form, k, c, d)
            GMat = Matrix(G)
            @test Matrix(adjoint(G)) ≈ adjoint(Matrix(G))
            @test Matrix(inv(G)) ≈ inv(Matrix(G))
        
            IR, IL = Matrix{Float64}(I, 2n, 2n), Matrix{Float64}(I, 2n, 2n)
            SIR, SIL = Symplectic(form, copy(IR)), Symplectic(form, copy(IL))
            lmul!(G, IL)
            rmul!(IR, G)
            lmul!(G, SIL)
            rmul!(SIR, G)
            @test isapprox(IL, GMat, atol = 1e-8) && isapprox(IR, GMat, atol = 1e-8)
            @test isapprox(SIL, Symplectic(form, GMat), atol = 1e-8) && isapprox(SIR, Symplectic(form, GMat))
        end
    end
end

"""
    SymplecticGivens <: AbstractMatrix

Matrix representation type of a symplectic Givens rotation on a symplectic basis.
This is the return type of [`givens(_)`](@ref), the corresponding rotation matrix function.

If `G::SymplecticGivens` is the rotation object, the mode `k`, cosine `c`, and sine `s` can be obtained
via `G.k`, `G.c`, and `G.s`, such that `c^2 + s^2 = 1`.

# Examples
```jldoctest
julia> G = givens(BlockForm(3), 2, pi/4)
SymplecticGivens{BlockForm{Int64}, Int64, Float64}:
 1.0    ⋅                   ⋅    ⋅    ⋅                   ⋅ 
  ⋅    0.7071067811865476   ⋅    ⋅   0.7071067811865475   ⋅ 
  ⋅     ⋅                  1.0   ⋅    ⋅                   ⋅ 
  ⋅     ⋅                   ⋅   1.0   ⋅                   ⋅ 
  ⋅   -0.7071067811865475   ⋅    ⋅   0.7071067811865476   ⋅ 
  ⋅     ⋅                   ⋅    ⋅    ⋅                  1.0

julia> k, c, s = G.k, G.c, G.s;

julia> c^2 + s^2 ≈ 1.0
true
```
"""
struct SymplecticGivens{F<:SymplecticForm,N<:Int,T} <: AbstractRotation{T}
    form::F
    k::N
    c::T
    s::T
    SymplecticGivens(form::F, k::N, c::T, s::T) where {F<:SymplecticForm,N<:Int,T} = new{F,N,T}(form, k, c, s)
end
SymplecticGivens(x::SymplecticGivens) = x

"""
    givens(form::SymplecticForm, k::Int, c::Number, s::Number) -> SymplecticGivens

Compute a symplectic Givens rotation of mode `k` and return a `SymplecticGivens` object.

The parameters `c` and `s` represent the cosine and sine of the rotation angle, satisfying `c^2 + s^2 = 1`. 
The transformation `G` performs a rotation in the `(k, n+k)` plane for `BlockForm` or the `(2k-1, 2k)` plane 
for `PairForm`.
"""
function givens(form::SymplecticForm, k::Int, θ::T) where {T}
    k < form.n || throw(ArgumentError("k must be less than n."))
    c, s = cos(θ), sin(θ)
    return SymplecticGivens(form, k, c, s)
end

function Base.Matrix(x::SymplecticGivens{F,N,T}) where {F<:BlockForm,N<:Int,T}
    n, k, c, s = (x.form).n, x.k, x.c, x.s
    M = zeros(T, 2n, 2n)
    @inbounds for i in Base.OneTo(n)
        if i == k
            M[i,i] = c
            M[i+n,i+n] = c
            M[i,i+n] = s
            M[i+n,i] = -s
        else
            M[i,i] = oneunit(c)
            M[i+n,i+n] = oneunit(c)
        end
    end
    return M
end
function Base.Matrix(x::SymplecticGivens{F,N,T}) where {F<:PairForm,N<:Int,T}
    n, k, c, s = (x.form).n, x.k, x.c, x.s
    M = Matrix{T}(I, 2n, 2n)
    M[2k-1,2k-1] = c
    M[2k-1,2k] = s
    M[2k,2k-1] = -s
    M[2k,2k] = c
    return M
end
Base.Array(x::SymplecticGivens) = Matrix(x)
function Base.AbstractMatrix{T1}(x::SymplecticGivens{F,N,T2}) where {F<:BlockForm,N<:Int,T1,T2}
    n, k, c, s = (x.form).n, x.k, x.c, x.s
    M = zeros(T1, 2n, 2n)
    @inbounds for i in Base.OneTo(n)
        if i == k
            M[i,i] = c
            M[i+n,i+n] = c
            M[i,i+n] = s
            M[i+n,i] = -s
        else
            M[i,i] = oneunit(c)
            M[i+n,i+n] = oneunit(c)
        end
    end
    return M
end
function Base.AbstractMatrix{T1}(x::SymplecticGivens{F,N,T2}) where {F<:PairForm,N<:Int,T1,T2}
    n, k, c, s = (x.form).n, x.k, x.c, x.s
    M = Matrix{T1}(I, 2n, 2n)
    M[2k-1,2k-1] = c
    M[2k-1,2k] = s
    M[2k,2k-1] = -s
    M[2k,2k] = c
    return M
end
Base.checkbounds(x::SymplecticGivens, i::Int, j::Int) = (form = x.form; i <= 2 * form.n && j <= 2 * form.n)
Base.checkbounds(x::SymplecticGivens, i::Int) = (form = x.form; i <= (2 * form.n)^2)
Base.isequal(x::SymplecticGivens, y::SymplecticGivens) = x.form == y.form && x.k == y.k && x.c == y.c && x.s == y.s
Base.isapprox(x::SymplecticGivens, y::SymplecticGivens) = x.form == y.form && isapprox(x.k, y.k) && isapprox(x.c, y.c) && isapprox(x.s, y.s)
Base.size(x::SymplecticGivens) = (form = x.form; (2 * form.n, 2 * form.n))
Base.size(x::SymplecticGivens, dim::Int) = (form = x.form; 2 * form.n)
Base.length(x::SymplecticGivens) = prod(size(x))
Base.axes(x::SymplecticGivens) = (form = x.form; (Base.OneTo(2 * form.n), Base.OneTo(2 * form.n)))
Base.eltype(x::SymplecticGivens) = eltype(x.c)

Base.@propagate_inbounds function Base.getindex(x::SymplecticGivens{F,N,T}, i::Int, j::Int) where {F<:BlockForm,N<:Int,T}
    @boundscheck checkbounds(x, i, j)
    n, k, c, s = (x.form).n, x.k, x.c, x.s
    if i == j
        if i == k || i == (n+k)
            return c
        else
            return oneunit(c)
        end
    elseif i == k && j == (n+k)
        return s
    elseif i == (n+k) && j == k
        return -s
    else 
        return zero(c)
    end
end
Base.@propagate_inbounds function Base.getindex(x::SymplecticGivens{F,N,T}, i::Int) where {F<:BlockForm,N<:Int,T}
    @boundscheck checkbounds(x, i)
    n, k, c, s = (x.form).n, x.k, x.c, x.s
    if i % (2n+1) == 1
        if (i-k) % (2n) == 0 || (i-n-k) % (2n) == 0
            return c
        else
            return oneunit(c)
        end
    elseif i == (2*n*k-n+k)
        return -s
    elseif i == (2*n^2+2n*(k-1)+k)
        return s
    else
        return zero(c)
    end
end
Base.@propagate_inbounds function Base.getindex(x::SymplecticGivens{F,N,T}, i::Int, j::Int) where {F<:PairForm,N<:Int,T}
    @boundscheck checkbounds(x, i, j)
    n, k, c, s = (x.form).n, x.k, x.c, x.s
    if i == j
        if i == (2k-1) || i == (2k)
            return c
        else
            return oneunit(c)
        end
    elseif i == (2k-1) && j == (2k)
        return s
    elseif i == (2k) && j == (2k-1)
        return -s
    else 
        return zero(c)
    end
end
Base.@propagate_inbounds function Base.getindex(x::SymplecticGivens{F,N,T}, i::Int) where {F<:PairForm,N<:Int,T}
    @boundscheck checkbounds(x, i)
    n, k, c, s = (x.form).n, x.k, x.c, x.s
    if i % (2n+1) == 1
        if i == (4*n*(k-1)+2k-1) || i == (4*n*(k-1)+2(n+k))
            return c
        else
            return oneunit(c)
        end
    elseif i == (4*n*(k-1)+2k)
        return -s
    elseif i == (4*n*(k-1)+2(n+k)-1)
        return s
    else
        return zero(c)
    end
end

LinearAlgebra.adjoint(x::SymplecticGivens) = SymplecticGivens(x.form, x.k, x.c, -x.s)
LinearAlgebra.inv(x::SymplecticGivens) = adjoint(x)
Base.copy(x::SymplecticGivens) = SymplecticGivens(x.form, copy(x.k), copy(x.c), copy(x.s))
@inline function Base.copyto!(dest::AbstractMatrix, src::SymplecticGivens{F,N,T}) where {F<:BlockForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(dest)
    size(dest, 1) == size(dest, 2) || throw(ArgumentError("cannot copy a SymplecticGivens object to a non-square matrix."))
    n, k, c, s = (src.form).n, src.k, src.c, src.s
    @inbounds for i in Base.OneTo(n)
        if i == k
            dest[i,i] = c
            dest[i+n,i+n] = c
            dest[i,i+n] = s
            dest[i+n,i] = -s
        else
            dest[i,i] = oneunit(c)
            dest[i+n,i+n] = oneunit(c)
        end
    end
end
@inline function Base.copyto!(dest::AbstractMatrix, src::SymplecticGivens{F,N,T}) where {F<:PairForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(dest)
    size(dest, 1) == size(dest, 2) || throw(ArgumentError("cannot copy a SymplecticGivens object to a non-square matrix."))
    n, k, c, s = (src.form).n, src.k, src.c, src.s
    @inbounds for i in Base.OneTo(n)
        if i == k
            dest[2i-1,2i-1] = c
            dest[2i,2i] = c
            dest[2i-1,2i] = s
            dest[2i,2i-1] = -s
        else
            dest[2i-1,2i-1] = oneunit(c)
            dest[2i,2i] = oneunit(c)
        end
    end
end

@inline function LinearAlgebra.lmul!(x::SymplecticGivens{F,N,T}, y::AbstractVecOrMat) where {F<:BlockForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(y)
    size(y, 1) == size(y, 2) || throw(ArgumentError("cannot compute the matrix product between a SymplecticGivens object and a non-square matrix."))
    n, k, c, s = (x.form).n, x.k, x.c, x.s
    @inbounds for i in Base.OneTo(n)
        y1, y2 = y[k,i], y[n+k,i]
        y1n, y2n = y[k,i+n], y[n+k,i+n]
        y[k,i] = c * y1 + s * y2
        y[k,i+n] = c * y1n + s * y2n
        y[n+k,i] = -s * y1 + c * y2
        y[n+k,i+n] = -s * y1n + c * y2n
    end
    return y
end
@inline function LinearAlgebra.rmul!(x::AbstractVecOrMat, y::SymplecticGivens{F,N,T}) where {F<:BlockForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(x)
    size(x, 1) == size(x, 2) || throw(ArgumentError("cannot compute the matrix product between a non-square matrix and SymplecticGivens object."))
    n, k, c, s = (y.form).n, y.k, y.c, y.s
    @inbounds for i in Base.OneTo(n)
        x1, x2 = x[i,k], x[i, n+k]
        x1n, x2n = x[i+n,k], x[i+n,n+k]
        x[i,k] = c * x1 - s * x2
        x[i+n,k] = c * x1n - s * x2n
        x[i,n+k] = s * x1 + c * x2
        x[i+n,n+k] = s * x1n + c * x2n
    end
    return x
end
@inline function LinearAlgebra.lmul!(x::SymplecticGivens{F,N,T}, y::AbstractVecOrMat) where {F<:PairForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(y)
    size(y, 1) == size(y, 2) || throw(ArgumentError("cannot compute the matrix product between a SymplecticGivens object and a non-square matrix."))
    n, k, c, s = (x.form).n, x.k, x.c, x.s
    @inbounds for i in Base.OneTo(n)
        y1, y2 = y[2k-1,2i-1], y[2k,2i-1]
        y1n, y2n = y[2k-1,2i], y[2k,2i]
        y[2k-1,2i-1] = c * y1 + s * y2
        y[2k-1,2i] = c * y1n + s * y2n
        y[2k,2i-1] = -s * y1 + c * y2
        y[2k,2i] = -s * y1n + c * y2n
    end
    return y
end
@inline function LinearAlgebra.rmul!(x::AbstractVecOrMat, y::SymplecticGivens{F,N,T}) where {F<:PairForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(x)
    size(x, 1) == size(x, 2) || throw(ArgumentError("cannot compute the matrix product between a non-square matrix and SymplecticGivens object."))
    n, k, c, s = (y.form).n, y.k, y.c, y.s
    @inbounds for i in Base.OneTo(n)
        x1, x2 = x[2i-1,2k-1], x[2i-1,2k]
        x1n, x2n = x[2i,2k-1], x[2i,2k]
        x[2i-1,2k-1] = c * x1 - s * x2
        x[2i,2k-1] = c * x1n - s * x2n
        x[2i-1,2k] = s * x1 + c * x2
        x[2i,2k] = s * x1n + c * x2n
    end
    return x
end
Base.:(*)(x::SymplecticGivens, y::SymplecticGivens) = x.k == y.k ? SymplecticGivens(x.form, x.k, x.c * y.c - x.s * y.s, x.c * y.s + x.s * y.c) : Symplectic(x.form, Matrix(x) * Matrix(y))
Base.:(*)(x::SymplecticGivens, y::Symplectic) = x.form == y.form ? Symplectic(x.form, x * y.data) : x * y.data
Base.:(*)(x::Symplectic, y::SymplecticGivens) = x.form == y.form ? Symplectic(x.form, x.data * y) : x.data * y
Base.:(/)(x::SymplecticGivens, y::SymplecticGivens) = x.k == y.k ? SymplecticGivens(x.form, x.k, (x.c * y.c + x.s * y.s)/(y.c^2 + y.s^2), (-x.c * y.s + y.c * x.s)/(y.c^2 + y.s^2)) : Symplectic(x.form, Matrix(x) / Matrix(y))
Base.:(/)(x::SymplecticGivens, y::Symplectic) = x.form == y.form ? Symplectic(x.form, x * inv(y.data)) : x * inv(y.data)
Base.:(/)(x::Symplectic, y::SymplecticGivens) = x.form == y.form ? Symplectic(x.form, x.data * inv(y)) : x.data * inv(y)
Base.:(/)(x::SymplecticGivens, y::AbstractMatrix) = x * inv(y)
Base.:(/)(x::AbstractMatrix, y::SymplecticGivens) = x * inv(y)
Base.:(\)(x::SymplecticGivens, y::SymplecticGivens) = x.k == y.k ? SymplecticGivens(x.form, x.k, (x.c * y.c + x.s * y.s)/(x.c^2 + x.s^2), (x.c * y.s - y.c * x.s)/(y.c^2 + y.s^2)) : Symplectic(x.form, Matrix(x) \ Matrix(y))
Base.:(\)(x::SymplecticGivens, y::Symplectic) = x.form == y.form ? Symplectic(x.form, inv(x) * y.data) : inv(x) * y.data
Base.:(\)(x::Symplectic, y::SymplecticGivens) = x.form == y.form ? Symplectic(x.form, inv(x.data) * y) : inv(x.data) * y
Base.:(\)(x::SymplecticGivens, y::AbstractMatrix) = inv(x) * y
Base.:(\)(x::AbstractMatrix, y::SymplecticGivens) = inv(x) * y

function Base.replace_in_print_matrix(x::SymplecticGivens{F,N,T}, i::Integer, j::Integer, s::AbstractString) where {F<:BlockForm,N<:Int,T}
    n, k = x.form.n, x.k
    in_active_block = (i == k || i == n + k) && (j == k || j == n + k)
    is_diag = (i == j)
    return (in_active_block || is_diag) ? s : Base.replace_with_centered_mark(s)
end
function Base.replace_in_print_matrix(x::SymplecticGivens{F,N,T}, i::Integer, j::Integer, s::AbstractString) where {F<:PairForm,N<:Int,T}
    k = x.k
    in_active_block = (i == 2k - 1 || i == 2k) && (j == 2k - 1 || j == 2k)
    is_diag = (i == j)
    return (in_active_block || is_diag) ? s : Base.replace_with_centered_mark(s)
end
# NOTE: this is an extremely hacky way to do the fancy sparse printing,
# but I'm not entirely sure how else to access the sparse printing infrastructure
# for the `SymplecticGivens type`, as it subtypes `AbstractRotation` and not
# `AbstractMatrix`. 
# TODO: find a better way to do the sparse printing without allocating.
struct SymplecticPrintWrapper{T, S} <: AbstractMatrix{T}
    parent::S
end
SymplecticPrintWrapper(x) = SymplecticPrintWrapper{eltype(x), typeof(x)}(x)
Base.size(w::SymplecticPrintWrapper) = size(w.parent)
Base.getindex(w::SymplecticPrintWrapper, i::Int, j::Int) = w.parent[i, j]
Base.replace_in_print_matrix(w::SymplecticPrintWrapper, i::Integer, j::Integer, s::AbstractString) = 
    Base.replace_in_print_matrix(w.parent, i, j, s)
function Base.show(io::IO, ::MIME"text/plain", x::SymplecticGivens)
    summary(io, x)
    println(io, ":")
    Base.print_matrix(io, SymplecticPrintWrapper(x))
end

"""
    SymplecticGauss <: AbstractMatrix

Matrix representation type of a symplectic Gauss transformation on a symplectic basis.
This is the return type of [`gauss(_)`](@ref), the corresponding transformation matrix function.

If `G::SymplecticGauss` is the transformation object, the mode `k` and parameters `c` and `d` can be obtained
via `G.k`, `G.c`, and `G.d`.

# Examples
```jldoctest
julia> G = gauss(PairForm(3), 2, 2.0, 3.0)
6×6 SymplecticGauss{PairForm{Int64}, Int64, Float64}:
 2.0   ⋅    ⋅   3.0   ⋅    ⋅ 
  ⋅   0.5   ⋅    ⋅    ⋅    ⋅ 
  ⋅   3.0  2.0   ⋅    ⋅    ⋅ 
  ⋅    ⋅    ⋅   0.5   ⋅    ⋅ 
  ⋅    ⋅    ⋅    ⋅   1.0   ⋅ 
  ⋅    ⋅    ⋅    ⋅    ⋅   1.0

julia> isapprox(G * inv(G), I)
true
```
"""
struct SymplecticGauss{F<:SymplecticForm,N<:Int,T} <: AbstractMatrix{T}
    form::F
    k::N
    c::T
    d::T
    SymplecticGauss(form::F, k::N, c::T, d::T) where {F<:SymplecticForm,N<:Int,T} = new{F,N,T}(form, k, c, d)
end
SymplecticGauss(x::SymplecticGauss) = x

"""
    gauss(form::SymplecticForm, k::Int, c::Number, d::Number) -> SymplecticGauss

Compute a symplectic Gauss transformation of mode `k` and return a `SymplecticGauss` object.

The parameters `c` and `d` define the scaling and shear of the transformation.
"""
function gauss(form::SymplecticForm, k::Int, c::T, d::T) where {T}
    2 <= k <= form.n || throw(ArgumentError("k must be between 2 and n."))
    return SymplecticGauss(form, k, c, d)
end

function Base.Matrix(x::SymplecticGauss{F,N,T}) where {F<:BlockForm,N<:Int,T}
    n, k, c, d = (x.form).n, x.k, x.c, x.d
    M = Matrix{T}(I, 2n, 2n)
    M[k-1, k-1] = c
    M[k, k] = c
    M[k-1, n+k] = d
    M[k, n+k-1] = d
    M[n+k-1, n+k-1] = inv(c)
    M[n+k, n+k] = inv(c)
    return M
end
function Base.Matrix(x::SymplecticGauss{F,N,T}) where {F<:PairForm,N<:Int,T}
    n, k, c, d = (x.form).n, x.k, x.c, x.d
    M = Matrix{T}(I, 2n, 2n)
    M[2k-3, 2k-3] = c
    M[2k-1, 2k-1] = c
    M[2k-3, 2k] = d
    M[2k-1, 2k-2] = d
    M[2k-2, 2k-2] = inv(c)
    M[2k, 2k] = inv(c)
    return M
end
Base.Array(x::SymplecticGauss) = Matrix(x)
function Base.AbstractMatrix{T1}(x::SymplecticGauss{F,N,T2}) where {F<:BlockForm,N<:Int,T1,T2}
    n, k, c, d = (x.form).n, x.k, x.c, x.d
    M = Matrix{T1}(I, 2n, 2n)
    M[k-1, k-1] = c
    M[k, k] = c
    M[k-1, n+k] = d
    M[k, n+k-1] = d
    M[n+k-1, n+k-1] = inv(c)
    M[n+k, n+k] = inv(c)
    return M
end
function Base.AbstractMatrix{T1}(x::SymplecticGauss{F,N,T2}) where {F<:PairForm,N<:Int,T1,T2}
    n, k, c, d = (x.form).n, x.k, x.c, x.d
    M = Matrix{T1}(I, 2n, 2n)
    M[2k-3, 2k-3] = c
    M[2k-1, 2k-1] = c
    M[2k-3, 2k] = d
    M[2k-1, 2k-2] = d
    M[2k-2, 2k-2] = inv(c)
    M[2k, 2k] = inv(c)
    return M
end

Base.checkbounds(x::SymplecticGauss, i::Int, j::Int) = (form = x.form; i <= 2 * form.n && j <= 2 * form.n)
Base.checkbounds(x::SymplecticGauss, i::Int) = (form = x.form; i <= (2 * form.n)^2)
Base.isequal(x::SymplecticGauss, y::SymplecticGauss) = x.form == y.form && x.k == y.k && x.c == y.c && x.d == y.d
Base.isapprox(x::SymplecticGauss, y::SymplecticGauss) = x.form == y.form && isapprox(x.k, y.k) && isapprox(x.c, y.c) && isapprox(x.d, y.d)
Base.size(x::SymplecticGauss) = (form = x.form; (2 * form.n, 2 * form.n))
Base.size(x::SymplecticGauss, dim::Int) = (form = x.form; 2 * form.n)
Base.length(x::SymplecticGauss) = prod(size(x))
Base.axes(x::SymplecticGauss) = (form = x.form; (Base.OneTo(2 * form.n), Base.OneTo(2 * form.n)))
Base.eltype(x::SymplecticGauss) = typeof(x.c)

Base.@propagate_inbounds function Base.getindex(x::SymplecticGauss{F,N,T}, i::Int, j::Int) where {F<:BlockForm,N<:Int,T}
    @boundscheck checkbounds(x, i, j)
    n, k, c, d = (x.form).n, x.k, x.c, x.d
    if i == j
        if i == k - 1 || i == k
            return c
        elseif i == n + k - 1 || i == n + k
            return inv(c)
        else
            return oneunit(T)
        end
    elseif i == k - 1 && j == n + k
        return d
    elseif i == k && j == n + k - 1
        return d
    else
        return zero(T)
    end
end
Base.@propagate_inbounds function Base.getindex(x::SymplecticGauss{F,N,T}, i::Int, j::Int) where {F<:PairForm,N<:Int,T}
    @boundscheck checkbounds(x, i, j)
    n, k, c, d = (x.form).n, x.k, x.c, x.d
    if i == j
        if i == 2k - 3 || i == 2k - 1
            return c
        elseif i == 2k - 2 || i == 2k
            return inv(c)
        else
            return oneunit(T)
        end
    elseif i == 2k - 3 && j == 2k
        return d
    elseif i == 2k - 1 && j == 2k - 2
        return d
    else
        return zero(T)
    end
end
Base.@propagate_inbounds function Base.getindex(x::SymplecticGauss, ind::Int)
    @boundscheck checkbounds(x, ind)
    n2 = 2 * x.form.n
    c_idx, r = divrem(ind - 1, n2)
    return x[r + 1, c_idx + 1]
end

LinearAlgebra.inv(x::SymplecticGauss) = SymplecticGauss(x.form, x.k, inv(x.c), -x.d)
Base.copy(x::SymplecticGauss) = SymplecticGauss(x.form, copy(x.k), copy(x.c), copy(x.d))

@inline function Base.copyto!(dest::AbstractMatrix, src::SymplecticGauss{F,N,T}) where {F<:BlockForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(dest)
    size(dest, 1) == size(dest, 2) || throw(ArgumentError("cannot copy a SymplecticGauss object to a non-square matrix."))
    n, k, c, d = (src.form).n, src.k, src.c, src.d
    fill!(dest, zero(T))
    @inbounds for i in axes(dest, 1)
        dest[i, i] = oneunit(T)
    end
    dest[k-1, k-1] = c
    dest[k, k] = c
    dest[k-1, n+k] = d
    dest[k, n+k-1] = d
    dest[n+k-1, n+k-1] = inv(c)
    dest[n+k, n+k] = inv(c)
    return dest
end
@inline function Base.copyto!(dest::Symplectic, src::SymplecticGauss{F,N,T}) where {F<:BlockForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(dest)
    @assert dest.form == src.form
    size(dest, 1) == size(dest, 2) || throw(ArgumentError("cannot copy a SymplecticGauss object to a non-square matrix."))
    n, k, c, d = (src.form).n, src.k, src.c, src.d
    fill!(dest, zero(T))
    @inbounds for i in axes(dest, 1)
        dest[i, i] = oneunit(T)
    end
    dest[k-1, k-1] = c
    dest[k, k] = c
    dest[k-1, n+k] = d
    dest[k, n+k-1] = d
    dest[n+k-1, n+k-1] = inv(c)
    dest[n+k, n+k] = inv(c)
    return dest
end
@inline function Base.copyto!(dest::AbstractMatrix, src::SymplecticGauss{F,N,T}) where {F<:PairForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(dest)
    size(dest, 1) == size(dest, 2) || throw(ArgumentError("cannot copy a SymplecticGauss object to a non-square matrix."))
    n, k, c, d = (src.form).n, src.k, src.c, src.d
    fill!(dest, zero(T))
    @inbounds for i in axes(dest, 1)
        dest[i, i] = oneunit(T)
    end
    dest[2k-3, 2k-3] = c
    dest[2k-1, 2k-1] = c
    dest[2k-3, 2k] = d
    dest[2k-1, 2k-2] = d
    dest[2k-2, 2k-2] = inv(c)
    dest[2k, 2k] = inv(c)
    return dest
end
@inline function Base.copyto!(dest::Symplectic, src::SymplecticGauss{F,N,T}) where {F<:PairForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(dest)
    @assert dest.form == src.form
    size(dest, 1) == size(dest, 2) || throw(ArgumentError("cannot copy a SymplecticGauss object to a non-square matrix."))
    n, k, c, d = (src.form).n, src.k, src.c, src.d
    fill!(dest, zero(T))
    @inbounds for i in axes(dest, 1)
        dest[i, i] = oneunit(T)
    end
    dest[2k-3, 2k-3] = c
    dest[2k-1, 2k-1] = c
    dest[2k-3, 2k] = d
    dest[2k-1, 2k-2] = d
    dest[2k-2, 2k-2] = inv(c)
    dest[2k, 2k] = inv(c)
    return dest
end

@inline function LinearAlgebra.lmul!(L::SymplecticGauss{F,N,T}, A::AbstractMatrix) where {F<:BlockForm,N<:Int,T}
    n, k, c, d = L.form.n, L.k, L.c, L.d
    @inbounds for j in axes(A, 2)
        a_km1 = A[k-1, j]
        a_k   = A[k, j]
        a_nkm1 = A[n+k-1, j]
        a_nk   = A[n+k, j]
        A[k-1, j] = c * a_km1 + d * a_nk
        A[k, j] = c * a_k + d * a_nkm1
        A[n+k-1, j] = inv(c) * a_nkm1
        A[n+k, j] = inv(c) * a_nk
    end
    return A
end
@inline function LinearAlgebra.lmul!(x::SymplecticGauss{F,N,T}, y::AbstractVector) where {F<:BlockForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(y)
    n, k, c, d = x.form.n, x.k, x.c, x.d
    a_km1 = y[k-1]
    a_k   = y[k]
    a_nkm1 = y[n+k-1]
    a_nk   = y[n+k]
    
    y[k-1] = c * a_km1 + d * a_nk
    y[k] = c * a_k + d * a_nkm1
    y[n+k-1] = inv(c) * a_nkm1
    y[n+k] = inv(c) * a_nk
    return y
end
@inline function LinearAlgebra.rmul!(A::AbstractMatrix, L::SymplecticGauss{F,N,T}) where {F<:BlockForm,N<:Int,T}
    n, k, c, d = L.form.n, L.k, L.c, L.d
    @inbounds for i in axes(A, 1)
        a_km1 = A[i, k-1]
        a_k   = A[i, k]
        a_nkm1 = A[i, n+k-1]
        a_nk   = A[i, n+k]
        
        A[i, k-1] = a_km1 * c
        A[i, k] = a_k * c
        A[i, n+k-1] = a_k * d + a_nkm1 * inv(c)
        A[i, n+k] = a_km1 * d + a_nk * inv(c)
    end
    return A
end
@inline function LinearAlgebra.lmul!(L::SymplecticGauss{F,N,T}, Y::AbstractMatrix) where {F<:PairForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(Y)
    size(Y, 1) == size(Y, 2) || throw(ArgumentError("cannot compute the matrix product between a SymplecticGauss object and a non-square matrix."))
    n, k, c, d = L.form.n, L.k, L.c, L.d
    @inbounds for j in axes(Y, 2)
        y_q1 = Y[2k-3, j]
        y_p1 = Y[2k-2, j]
        y_q2 = Y[2k-1, j]
        y_p2 = Y[2k, j]
        
        Y[2k-3, j] = c * y_q1 + d * y_p2
        Y[2k-1, j] = c * y_q2 + d * y_p1
        Y[2k-2, j] = inv(c) * y_p1
        Y[2k, j] = inv(c) * y_p2
    end
    return Y
end
@inline function LinearAlgebra.lmul!(x::SymplecticGauss{F,N,T}, y::AbstractVector) where {F<:PairForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(y)
    n, k, c, d = x.form.n, x.k, x.c, x.d
    y_q1 = y[2k-3]
    y_p1 = y[2k-2]
    y_q2 = y[2k-1]
    y_p2 = y[2k]
    
    y[2k-3] = c * y_q1 + d * y_p2
    y[2k-1] = c * y_q2 + d * y_p1
    y[2k-2] = inv(c) * y_p1
    y[2k] = inv(c) * y_p2
    return y
end
@inline function LinearAlgebra.rmul!(X::AbstractMatrix, L::SymplecticGauss{F,N,T}) where {F<:PairForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(X)
    size(X, 1) == size(X, 2) || throw(ArgumentError("cannot compute the matrix product between a SymplecticGauss object and a non-square matrix."))
    n, k, c, d = L.form.n, L.k, L.c, L.d
    @inbounds for i in axes(X, 1)
        x_q1 = X[i, 2k-3]
        x_p1 = X[i, 2k-2]
        x_q2 = X[i, 2k-1]
        x_p2 = X[i, 2k]
        
        X[i, 2k-3] = x_q1 * c
        X[i, 2k-1] = x_q2 * c
        X[i, 2k-2] = x_q2 * d + x_p1 * inv(c)
        X[i, 2k] = x_q1 * d + x_p2 * inv(c)
    end
    return X
end

Base.:(*)(x::SymplecticGauss, y::SymplecticGauss) = x.k == y.k ? SymplecticGauss(x.form, x.k, x.c * y.c, x.c * y.d + x.d * inv(y.c)) : Symplectic(x.form, Matrix(x) * Matrix(y))
Base.:(*)(x::SymplecticGauss, y::Symplectic) = x.form == y.form ? Symplectic(x.form, x * y.data) : x * y.data
Base.:(*)(x::Symplectic, y::SymplecticGauss) = x.form == y.form ? Symplectic(x.form, x.data * y) : x.data * y
Base.:(/)(x::SymplecticGauss, y::SymplecticGauss) = x.k == y.k ? x * inv(y) : Symplectic(x.form, Matrix(x) / Matrix(y))
Base.:(/)(x::SymplecticGauss, y::Symplectic) = x.form == y.form ? Symplectic(x.form, x * inv(y.data)) : x * inv(y.data)
Base.:(/)(x::Symplectic, y::SymplecticGauss) = x.form == y.form ? Symplectic(x.form, x.data * inv(y)) : x.data * inv(y)
Base.:(/)(x::SymplecticGauss, y::AbstractMatrix) = x * inv(y)
Base.:(/)(x::AbstractMatrix, y::SymplecticGauss) = x * inv(y)
Base.:(\)(x::SymplecticGauss, y::SymplecticGauss) = x.k == y.k ? inv(x) * y : Symplectic(x.form, Matrix(x) \ Matrix(y))
Base.:(\)(x::SymplecticGauss, y::Symplectic) = x.form == y.form ? Symplectic(x.form, inv(x) * y.data) : inv(x) * y.data
Base.:(\)(x::Symplectic, y::SymplecticGauss) = x.form == y.form ? Symplectic(x.form, inv(x.data) * y) : inv(x.data) * y
Base.:(\)(x::SymplecticGauss, y::AbstractMatrix) = inv(x) * y
Base.:(\)(x::AbstractMatrix, y::SymplecticGauss) = inv(x) * y

function Base.replace_in_print_matrix(G::SymplecticGauss, i::Integer, j::Integer, s::AbstractString)
    if G[i,j] == 0
        return Base.replace_with_centered_mark(s)
    else
        return s
    end
end

"""
    Williamson <: Factorization

Matrix factorization type of the williamson decomposition of a positive-definite matrix `V`.
This is the return type of [`williamson(_)`](@ref), the corresponding matrix factorization function.

If `F::Williamson` is the factorization object, `S` and `spectrum` can be obtained
via `F.S` and `F.spectrum`.

Iterating the decomposition produces the components `S` and `spectrum`.

# Examples
```
julia> V = [7. 2.; 2. 1.]
2×2 Matrix{Float64}:
 7.0  2.0
 2.0  1.0

julia> isposdef(V)
true

julia> F = williamson(BlockForm(1), V)
Williamson{Float64, Matrix{Float64}, Vector{Float64}}
S factor:
2×2 Matrix{Float64}:
 0.448828  -1.95959
 0.61311   -0.448828
symplectic spectrum:
1-element Vector{Float64}:
 1.7320508075688772

julia> isapprox(F.S * V * F.S', Diagonal(repeat(F.spectrum, 2)))
true

julia> S, spectrum = F; # destructuring via iteration

julia> S == F.S && spectrum == F.spectrum
true
```
"""
struct Williamson{T,M<:AbstractArray{T},N<:AbstractVector{T}} <: Factorization{T}
    S::M
    spectrum::N
    function Williamson{T,M,N}(S, spectrum) where {T,M<:AbstractArray{T},N<:AbstractVector{T}}
        require_one_based_indexing(S, spectrum)
        new{T,M,N}(S, spectrum)
    end
end
Williamson{T}(S::AbstractArray{T}, spectrum::AbstractVector{T},) where {T} = Williamson{T,typeof(S),typeof(spectrum)}(S, spectrum)

# iteration for destructuring into components
Base.iterate(F::Williamson) = (F.S, Val(:spectrum))
Base.iterate(F::Williamson, ::Val{:spectrum}) = (F.spectrum, Val(:done))
Base.iterate(F::Williamson, ::Val{:done}) = nothing

"""
    williamson(form::SymplecticForm, V::AbstractMatrix) -> Williamson
    williamson(::Symplectic, form::SymplecticForm, V::AbstractMatrix) -> Williamson

Compute the williamson decomposition of a positive-definite matrix `V` and return a `Williamson` object.

A symplectic matrix `S` and symplectic spectrum `spectrum` can be obtained
via `F.S` and `F.spectrum`.

Iterating the decomposition produces the components `S` and `spectrum`.

# Examples
```
julia> V = [7. 2.; 2. 1.]
2×2 Matrix{Float64}:
 7.0  2.0
 2.0  1.0

julia> isposdef(V)
true

julia> F = williamson(BlockForm(1), V)
Williamson{Float64, Matrix{Float64}, Vector{Float64}}
S factor:
2×2 Matrix{Float64}:
 0.448828  -1.95959
 0.61311   -0.448828
symplectic spectrum:
1-element Vector{Float64}:
 1.7320508075688772

julia> isapprox(F.S * V * F.S', Diagonal(repeat(F.spectrum, 2)))
true

julia> S, spectrum = F; # destructuring via iteration

julia> S == F.S && spectrum == F.spectrum
true
```
"""
function williamson(form::F, x::AbstractMatrix{T}) where {F<:SymplecticForm, T<:Real}
    S, spectrum = _williamson(form, x)
    return Williamson{T}(S, spectrum)
end
function williamson(::Type{Symplectic}, form::F, x::AbstractMatrix{T}) where {F<:SymplecticForm, T<:Real}
    S, spectrum = _williamson(form, x)
    return Williamson{T}(Symplectic(form, S), spectrum)
end
function _williamson(form::PairForm, x::AbstractMatrix{T}) where {T<:Real}
    J = symplecticform(form)
    spectrum = filter(i -> i > 0, imag.(eigvals(J * x, sortby = λ -> abs(λ))))
    D = Diagonal(repeat(spectrum, inner = 2))
    sqrtV = Symmetric(x)^(-1//2)
    X = sqrtV * J * sqrtV
    U = eigvecs(X, sortby = λ -> -abs(λ))
    G = zeros(ComplexF64, 2*form.n, 2*form.n)
    @inbounds for i in Base.OneTo(form.n)
        G[2i-1, 2i-1] = -im/sqrt(2)
        G[2i-1, 2i] = im/sqrt(2)
        G[2i, 2i-1] = 1/sqrt(2)
        G[2i, 2i] = 1/sqrt(2)
    end
    R = real(G * U')
    S = sqrt(D) * R * sqrtV
    return S, spectrum
end
function _williamson(form::BlockForm, x::AbstractMatrix{T}) where {T<:Real}
    J = symplecticform(form)
    spectrum = filter(i -> i > 0, imag.(eigvals(J * x, sortby = λ -> abs(λ))))
    D = Diagonal(repeat(spectrum, 2))
    sqrtV = Symmetric(x)^(-1//2)
    X = sqrtV * J * sqrtV
    U = eigvecs(X, sortby = λ -> (-sign(imag(λ)), -abs(λ)))
    G = zeros(ComplexF64, 2*form.n, 2*form.n)
    @inbounds for i in Base.OneTo(form.n)
        G[i, i] = -im/sqrt(2)
        G[i, i+form.n] = im/sqrt(2)
        G[i+form.n, i] = 1/sqrt(2)
        G[i+form.n, i+form.n] = 1/sqrt(2)
    end
    R = real(G * U')
    S = sqrt(D) * R * sqrtV
    return S, spectrum
end

function Base.show(io::IO, mime::MIME{Symbol("text/plain")}, F::Williamson{<:Any,<:AbstractArray,<:AbstractVector})
    Base.summary(io, F); println(io)
    println(io, "S factor:")
    Base.show(io, mime, F.S)
    println(io, "\nsymplectic spectrum:")
    Base.show(io, mime, F.spectrum)
end

@testitem "polar decomposition" begin
    using SymplecticMatrices
    using LinearAlgebra: adjoint, isposdef, eigvals

    @testset "random objects" begin

        n = rand(1:5)
        J = BlockForm(n)
        Omega = PairForm(n)
        S_block = randsymplectic(J)
        S_pair = randsymplectic(Omega)

        F_block = polar(S_block)
        O_block, P_block = polar(S_block)
        @test F_block.O == O_block && F_block.P == P_block
        F_pair = polar(S_pair)
        O_pair, P_pair = polar(S_pair)
        @test F_pair.O == O_pair && F_pair.P == P_pair 
        @test issymplectic(J, O_block, atol = 1e-5) && issymplectic(J, P_block, atol = 1e-5) 
        @test issymplectic(Omega, O_pair, atol = 1e-5) && issymplectic(Omega, P_pair, atol = 1e-5)
        @test isapprox(inv(O_pair), transpose(O_pair), atol = 1e-5) && isapprox(inv(O_block), transpose(O_block), atol = 1e-5)
        @test isapprox(P_block, transpose(P_block), atol = 1e-5) && all(i > 0 for i in eigvals(P_block))
        @test isapprox(P_pair, transpose(P_pair), atol = 1e-5) && all(i > 0 for i in eigvals(P_pair))
        @test isapprox(O_block * P_block, S_block, atol = 1e-5) && isapprox(O_pair * P_pair, S_pair, atol = 1e-5)
    end

    @testset "symplectic type" begin
        n = rand(1:5)
        J = BlockForm(n)
        Omega = PairForm(n)
        S_block = randsymplectic(Symplectic, J)
        S_pair = randsymplectic(Symplectic, Omega)

        F_block = polar(S_block)
        O_block, P_block = polar(S_block)
        @test F_block.O == O_block && F_block.P == P_block
        F_pair = polar(S_pair)
        O_pair, P_pair = polar(S_pair)
        @test F_pair.O == O_pair && F_pair.P == P_pair
        @test O_block isa Symplectic && O_pair isa Symplectic
        @test P_block isa Symplectic && P_pair isa Symplectic
        @test issymplectic(O_block, atol = 1e-5) && issymplectic(P_block, atol = 1e-5) 
        @test issymplectic(O_pair, atol = 1e-5) && issymplectic(P_pair, atol = 1e-5)
        @test isapprox(inv(O_pair), transpose(O_pair), atol = 1e-5) && isapprox(inv(O_block), transpose(O_block), atol = 1e-5)
        @test isapprox(P_block, transpose(P_block), atol = 1e-5) && all(i > 0 for i in eigvals(P_block.data))
        @test isapprox(P_pair, transpose(P_pair), atol = 1e-5) && all(i > 0 for i in eigvals(P_pair.data))
        @test isapprox(O_block * P_block, S_block, atol = 1e-5) && isapprox(O_pair * P_pair, S_pair, atol = 1e-5)
    end
end

abstract type SymplecticForm{N} end

struct BlockForm{N<:Int} <: SymplecticForm{N}
    n::N
end
struct PairForm{N<:Int} <: SymplecticForm{N}
    n::N
end
function Base.show(io::IO, x::SymplecticForm)
    print(io, "$(nameof(typeof(x)))($(x.n))")
end
function symplecticform(f::BlockForm)
    N = f.n
    Omega = zeros(2*N, 2*N)
    @inbounds for i in 1:N, j in N:2*N
        if isequal(i, j-N)
            Omega[i,j] = 1.0
        end
    end
    @inbounds for i in N:2*N, j in 1:N
        if isequal(i-N,j)
            Omega[i, j] = -1.0
        end
    end
    return Omega
end
function symplecticform(f::PairForm)
    N = f.n
    Omega = zeros(2*N, 2*N)
    @inbounds for i in Base.OneTo(N)
        Omega[2*i-1, 2*i] = 1.0
        Omega[2*i, 2*i-1] = -1.0
    end
    return Omega
end

@testitem "bloch-messiah decomposition" begin
    using SymplecticMatrices
    using LinearAlgebra: transpose, Diagonal

    @testset "random objects" begin

        rn = rand(2:5)
        n = 2 * rn
        J = BlockForm(rn)
        Omega = PairForm(rn)
        S_block = randsymplectic(J)
        S_pair = randsymplectic(Omega)

        F_block = blochmessiah(J, S_block)
        O_block, vals_block, Q_block = blochmessiah(J, S_block)
        @test F_block.O == O_block && F_block.values == vals_block && F_block.Q == Q_block
        F_pair = blochmessiah(Omega, S_pair)
        O_pair, vals_pair, Q_pair = blochmessiah(Omega, S_pair)
        @test F_pair.O == O_pair && F_pair.values == vals_pair && F_pair.Q == Q_pair
        @test issymplectic(Omega, O_pair, atol = 1e-5) && issymplectic(J, O_block, atol = 1e-5)
        @test issymplectic(Omega, Q_pair, atol = 1e-5) && issymplectic(J, Q_block, atol = 1e-5)
        @test isapprox(inv(O_pair), transpose(O_pair), atol = 1e-5) && isapprox(inv(O_block), transpose(O_block), atol = 1e-5)
        @test isapprox(inv(Q_pair), transpose(Q_pair), atol = 1e-5) && isapprox(inv(Q_block), transpose(Q_block), atol = 1e-5)

        @test all(x -> x > 0.0, vals_block) && all(x -> x > 0.0, vals_pair)
        D_block = Diagonal(vcat(vals_block, vals_block .^ (-1)))
        D_pair = Diagonal(collect(Iterators.flatten(zip(vals_pair, vals_pair .^ (-1)))))
        @test isapprox(O_block * D_block * Q_block, S_block, atol = 1e-5)
        @test isapprox(O_pair * D_pair * Q_pair, S_pair, atol = 1e-5)
    end

    @testset "symplectic type" begin

        rn = rand(2:5)
        n = 2 * rn
        J = BlockForm(rn)
        Omega = PairForm(rn)
        S_block = randsymplectic(Symplectic, J)
        S_pair = randsymplectic(Symplectic, Omega)

        F_block = blochmessiah(S_block)
        O_block, vals_block, Q_block = blochmessiah(S_block)
        @test F_block.O == O_block && F_block.values == vals_block && F_block.Q == Q_block
        F_pair = blochmessiah(S_pair)
        O_pair, vals_pair, Q_pair = blochmessiah(S_pair)
        @test F_pair.O == O_pair && F_pair.values == vals_pair && F_pair.Q == Q_pair
        @test issymplectic(O_pair, atol = 1e-5) && issymplectic(O_block, atol = 1e-5)
        @test issymplectic(Q_pair, atol = 1e-5) && issymplectic(Q_block, atol = 1e-5)
        @test isapprox(inv(O_pair), transpose(O_pair), atol = 1e-5) && isapprox(inv(O_block), transpose(O_block), atol = 1e-5)
        @test isapprox(inv(Q_pair), transpose(Q_pair), atol = 1e-5) && isapprox(inv(Q_block), transpose(Q_block), atol = 1e-5)

        @test all(x -> x > 0.0, vals_block) && all(x -> x > 0.0, vals_pair)
        D_block = Diagonal(vcat(vals_block, vals_block .^ (-1)))
        D_pair = Diagonal(collect(Iterators.flatten(zip(vals_pair, vals_pair .^ (-1)))))
        @test isapprox(O_block * D_block * Q_block, S_block, atol = 1e-5)
        @test isapprox(O_pair * D_pair * Q_pair, S_pair, atol = 1e-5)
    end
end

@testitem "givens" begin
    using SymplecticMatrices
    using LinearAlgebra: I, adjoint, inv, lmul!, rmul!

    @testset "predefined givens transformations" begin
        θ = rand(Float64)
        c, s = cos(θ), sin(θ)
        G_block, G_pair = givens(BlockForm(4), 2, θ), givens(PairForm(4), 2, θ)
        M_block = [1. 0. 0. 0. 0. 0. 0. 0.;
                   0. c  0. 0. 0. s  0. 0.;
                   0. 0. 1. 0. 0. 0. 0. 0.;
                   0. 0. 0. 1. 0. 0. 0. 0.;
                   0. 0. 0. 0. 1. 0. 0. 0.;
                   0. -s 0. 0. 0. c  0. 0.;
                   0. 0. 0. 0. 0. 0. 1. 0.;
                   0. 0. 0. 0. 0. 0. 0. 1.]
        M_pair =  [1. 0. 0. 0. 0. 0. 0. 0.;
                   0. 1. 0. 0. 0. 0. 0. 0.;
                   0. 0. c  s  0. 0. 0. 0.;
                   0. 0. -s c  0. 0. 0. 0.;
                   0. 0. 0. 0. 1. 0. 0. 0.;
                   0. 0. 0. 0. 0. 1. 0. 0.;
                   0. 0. 0. 0. 0. 0. 1. 0.;
                   0. 0. 0. 0. 0. 0. 0. 1.]
        @test M_block == Matrix(G_block) && M_pair == Matrix(G_pair)
        @test M_block == Array(G_block) && M_pair == Array(G_pair)
        @test AbstractMatrix{Float32}(M_block) == AbstractMatrix{Float32}(G_block) && AbstractMatrix{Float32}(M_pair) == AbstractMatrix{Float32}(G_pair)
        @test G_block[1,1] == G_block[3,3] == G_block[4,4] == 1.0
        @test G_block[5,5] == G_block[7,7] == G_block[8,8] == 1.0
        @test G_block[2,2] == G_block[6,6] == c
        @test G_block[6,2] == -s && G_block[2,6] == s
        @test G_block[1,2] == G_block[2,1] == G_block[7,8] == G_block[8,7] == 0.0
        @test  G_pair[1,1] ==  G_pair[2,2] ==  G_pair[5,5] == 1.0
        @test  G_pair[6,6] ==  G_pair[7,7] ==  G_pair[8,8] == 1.0
        @test  G_pair[3,3] ==  G_pair[4,4] == c
        @test  G_pair[4,3] == -s && G_pair[3,4] == s
        @test  G_pair[1,2] ==  G_pair[2,1] ==  G_pair[7,8] == G_pair[8,7] == 0.0
        @test  G_block[1]  ==  G_block[19] ==  G_block[28] == 1.0
        @test  G_block[37] ==  G_block[55] ==  G_block[64] == 1.0
        @test  G_block[10] ==  G_block[46] == c
        @test  G_block[14] == -s &&  G_block[42] == s
        @test  G_block[2]  ==   G_block[9] ==  G_block[56] == G_block[63] == 0.0
        @test   G_pair[1]  ==   G_pair[10] ==  G_pair[37] == 1.0
        @test   G_pair[46] ==   G_pair[55] ==  G_pair[64] == 1.0
        @test   G_pair[19] ==   G_pair[28] == c
        @test   G_pair[20] == -s &&  G_pair[27] == s
        @test   G_pair[2]  ==    G_pair[9] ==  G_pair[56] ==   G_pair[63] == 0.0
        
    end
    @testset "base methods" begin
        n = rand(3:5)
        k, θ = rand(2:5), rand(Float64)
        n = 2 * n
        J, Omega = BlockForm(n), PairForm(n)
        M = rand(Float64, 2n, 2n)

        @inbounds for form in [J, Omega]
            G = givens(form, k, θ)
            Gnew = givens(form, k-1, θ+0.3)
            @test isequal(G, copy(G)) && isapprox(G, copy(G))
            @test SymplecticGivens(G) == G
            @test copy(G) == G
            @test size(G) == (2n, 2n) && size(G, 1) == size(G, 2) == 2n
            @test length(G) == 4n^2
            @test axes(G) == (1:2n, 1:2n)
            @test eltype(G) == Float64

            GMat = Matrix(G)
            GMatnew = Matrix(Gnew)
            i, j = rand(1:2n), rand(1:2n)
            ind = rand(1:4n^2)
            @test G[i,j] == GMat[i,j] && G[j,i] == GMat[j,i]
            @test G[i] == GMat[i] && G[j] == GMat[j] && G[ind] == GMat[ind]

            Z = zeros(Float64, 2n, 2n)
            SZ = Symplectic(form, copy(Z))
            copyto!(Z, G)
            copyto!(SZ, G)
            @test isapprox(Z, GMat, atol = 1e-8) && isapprox(SZ, Symplectic(form, GMat), atol = 1e-8)
            @test isapprox(G * M, GMat * M, atol = 1e-8) && isapprox(M * G, M * GMat, atol = 1e-8)
            @test isapprox(Matrix(G * G), GMat * GMat, atol = 1e-8) && isapprox(Symplectic(form, Matrix(Gnew * G)), Symplectic(form, GMatnew * GMat), atol = 1e-8)
            @test isapprox(G * Symplectic(form, M), Symplectic(form, GMat * M), atol = 1e-8) && isapprox(Symplectic(form, M) * G, Symplectic(form, M * GMat), atol = 1e-8)
            @test isapprox(G / M, GMat / M, atol = 1e-8) && isapprox(M / G, M / GMat, atol = 1e-8)
            @test isapprox(Matrix(G / G), GMat / GMat, atol = 1e-8) && isapprox(Symplectic(form, Matrix(Gnew / G)), Symplectic(form, GMatnew / GMat), atol = 1e-8)
            @test isapprox(G / Symplectic(form, M), Symplectic(form, GMat / M), atol = 1e-8) && isapprox(Symplectic(form, M) / G, Symplectic(form, M / GMat), atol = 1e-8)
            @test isapprox(G \ M, GMat \ M, atol = 1e-8) && isapprox(M \ G, M \ GMat, atol = 1e-8)
            @test isapprox(Matrix(G \ G), GMat \ GMat, atol = 1e-8) && isapprox(Symplectic(form, Matrix(Gnew \ G)), Symplectic(form, GMatnew \ GMat), atol = 1e-8)
            @test isapprox(G \ Symplectic(form, M), Symplectic(form, GMat \ M), atol = 1e-8) && isapprox(Symplectic(form, M) \ G, Symplectic(form, M \ GMat), atol = 1e-8)
        end
    end
    @testset "LinearAlgebra methods" begin
        n = rand(3:5)
        k, θ = rand(2:n), rand(Float64)
        n = 2 * n
        J, Omega = BlockForm(n), PairForm(n)

        @inbounds for form in [J, Omega]
            G = givens(form, k, θ)
            GMat = Matrix(G)
            @test adjoint(G) == inv(G) == SymplecticGivens(form, k, cos(θ), -sin(θ))
        
            IR, IL = Matrix{Float64}(I, 2n, 2n), Matrix{Float64}(I, 2n, 2n)
            SIR, SIL = Symplectic(form, copy(IR)), Symplectic(form, copy(IL))
            lmul!(G, IL)
            rmul!(IR, G)
            lmul!(G, SIL)
            rmul!(SIR, G)
            @test isapprox(IL, GMat, atol = 1e-8) && isapprox(IR, GMat, atol = 1e-8)
            @test isapprox(SIL, Symplectic(form, GMat), atol = 1e-8) && isapprox(SIR, Symplectic(form, GMat))
        end
    end
end

@testitem "Doctests" tags=[:doctests] begin
    using Documenter
    using SymplecticMatrices

    DocMeta.setdocmeta!(SymplecticMatrices, :DocTestSetup, :(using SymplecticMatrices, LinearAlgebra); recursive=true)
    doctest(SymplecticMatrices)
end

@testitem "williamson decomposition" begin
    using SymplecticMatrices
    using LinearAlgebra: adjoint, eigvals, transpose, Diagonal

    @testset "random objects" begin

        rn = rand(2:10)
        n = 2 * rn
        J = BlockForm(rn)
        Omega = PairForm(rn)
        X = rand(n, n)
        V = X' * X

        F_block = williamson(J, V)
        S_block, spectrum_block = williamson(J, V)
        @test F_block.S == S_block && F_block.spectrum == spectrum_block
        F_pair = williamson(Omega, V)
        S_pair, spectrum_pair = williamson(Omega, V)
        @test F_pair.S == S_pair && F_pair.spectrum == spectrum_pair
        @test issymplectic(Omega, S_pair, atol = 1e-5) && issymplectic(J, S_block, atol = 1e-5)
        @test isapprox(S_pair * V * transpose(S_pair), Matrix(Diagonal(repeat(spectrum_pair, inner = 2))), atol = 1e-5)
        @test isapprox(S_block * V * transpose(S_block), Matrix(Diagonal(repeat(spectrum_block, 2))), atol = 1e-5)
    end

    @testset "symplectic type" begin

        rn = rand(2:5)
        n = 2 * rn
        J = BlockForm(rn)
        Omega = PairForm(rn)
        X = rand(n, n)
        V = X' * X

        F_block = williamson(Symplectic, J, V)
        S_block, spectrum_block = williamson(Symplectic, J, V)

        @test F_block.S == S_block && F_block.spectrum == spectrum_block
        F_pair = williamson(Symplectic, Omega, V)
        S_pair, spectrum_pair = williamson(Symplectic, Omega, V)
        @test F_pair.S == S_pair && F_pair.spectrum == spectrum_pair

        @test S_block isa Symplectic && S_pair isa Symplectic
        @test issymplectic(S_pair, atol = 1e-5) && issymplectic(S_block, atol = 1e-5)
        @test isapprox(S_pair * V * transpose(S_pair), Matrix(Diagonal(repeat(spectrum_pair, inner = 2))), atol = 1e-5)
        @test isapprox(S_block * V * transpose(S_block), Matrix(Diagonal(repeat(spectrum_block, 2))), atol = 1e-5)
    end
end

@testitem "symplectic features" begin
    using SymplecticMatrices
    using LinearAlgebra: Diagonal, adjoint, Symmetric

    @testset "random objects" begin

        n = rand(1:5)
        R_sym = Symmetric(rand(Float64, n, n))
        C_sym = Symmetric(rand(ComplexF64, n, n))

        Fr_sym = takagi(R_sym)
        Qr_sym, Sr_sym = takagi(R_sym)
        @test Fr_sym.Q == Qr_sym && Fr_sym.S == Sr_sym
        @test isapprox(Qr_sym * Diagonal(Sr_sym) * transpose(Qr_sym), Matrix{ComplexF64}(R_sym), atol=1e-5)
        
        #= error on LinearAlgebra.jl end
        @test Fc_sym = takagi(C_sym)
        @test Qc_sym, Sc_sym = takagi(C_sym)
        @test Fc_sym.Q == Qc_sym && Fc_sym.S == Sc_sym
        @testisapprox(Qc_sym * Diagonal(Sc_sym) * transpose(Qc_sym), Matrix(C_sym), atol=1e-5)
        =#
    end
end

struct Symplectic{F<:SymplecticForm, T<:Number, D<:AbstractMatrix{<:T}} <: AbstractMatrix{T}
    form::F
    data::D
    function Symplectic{F,T,D}(form, data) where {F<:SymplecticForm,T<:Number,D<:AbstractMatrix{<:T}}
        LinearAlgebra.require_one_based_indexing(data)
        new{F,T,D}(form, data)
    end
end

"""
    Symplectic(J::SymplecticForm, S::AbstractMatrix) <: AbstractMatrix

Construct a wrapper of a symplectic matrix `S` with its corresponding symplectic basis
defined by the symplectic form `J`.
"""
Symplectic(form::F, data::D) where {F<:SymplecticForm, D<:AbstractMatrix} = Symplectic{F,eltype(D),D}(form, data)
Symplectic(x::Symplectic) = x

Base.isequal(x::Symplectic, y::Symplectic) = x.form == y.form && x.data == y.data
Base.isapprox(x::Symplectic, y::Symplectic) = x.form == y.form && isapprox(x.data, y.data)
Base.size(x::Symplectic) = size(x.data)
Base.size(x::Symplectic, n) = size(x.data, n)
Base.axes(x::Symplectic) = axes(x.data)
Base.eltype(x::Symplectic) = eltype(x.data)

Base.@propagate_inbounds Base.getindex(x::Symplectic, i::Int) = x.data[i]
Base.@propagate_inbounds Base.getindex(x::Symplectic, i::Int, j::Int) = x.data[i,j]
Base.@propagate_inbounds Base.setindex!(x::Symplectic, v, i::Int) = setindex!(x.data, v, i)
Base.@propagate_inbounds Base.setindex!(x::Symplectic, v, i::Int, j::Int) = setindex!(x.data, v, i, j)

Base.similar(x::Symplectic, ::Type{T}) where {T} = Symplectic(x.form, similar(x.data, T))
Base.similar(x::Symplectic, dims::Dims{N}) where {N} = Symplectic(x.form, similar(x.data, dims))
Base.similar(x::Symplectic, ::Type{T}, dims::Dims{N}) where {T,N} = Symplectic(x.form, similar(x.data, T, dims))

Base.Matrix(x::Symplectic) = Matrix(x.data)
Base.Array(x::Symplectic) = Matrix(x)
Base.AbstractMatrix{T}(x::Symplectic) where {T} = Symplectic(x.form, AbstractMatrix{T}(x.data))
Base.parent(x::Symplectic) = x.data

Base.copy(x::Symplectic) = Symplectic(x.form, copy(x.data))
Base.copyto!(dest::Symplectic, src::Symplectic) = (copyto!(dest.data, src.data); return dest)
Base.copyto!(dest::Symplectic, src::AbstractMatrix) = (copyto!(dest.data, src); return dest)
Base.copyto!(dest::AbstractMatrix, src::Symplectic) = (copyto!(dest, src.data); return dest)

for f in (:lu, :lu!, :lq, :lq!, :qr, :qr!, :schur, :schur!, :hessenberg, :hessenberg!)
    @eval LinearAlgebra.$f(x::Symplectic; kwargs...) = LinearAlgebra.$f(x.data; kwargs...)
end
for f in (:svd, :svd!, :svdvals, :svdvals!, :eigvals, :eigvals!, :eigvecs, :eigen, :eigen!)
    @eval LinearAlgebra.$f(x::Symplectic; kwargs...) = LinearAlgebra.$f(x.data; kwargs...)
end
for f in (:det, :tr, :pinv, :logdet)
    @eval LinearAlgebra.$f(x::Symplectic; kwargs...) = LinearAlgebra.$f(x.data; kwargs...)
end
function LinearAlgebra.inv(x::Symplectic)
    J = symplecticform(x.form)
    Sinv = -J * transpose(x.data) * J
    return Symplectic(x.form, Sinv)
end
function LinearAlgebra.mul!(x::Symplectic, y::Symplectic, z::Symplectic)
    if x.form == y.form == z.form
        mul!(x.data, y.data, z.data)
        return x
    else
        mul!(x.data, y.data, z.data)
        return x.data
    end
end
Base.:(*)(x::Symplectic, y::Symplectic) = x.form == y.form ? Symplectic(x.form, x.data * y.data) : x.data * y.data
Base.:(/)(x::Symplectic, y::Symplectic) = x.form == y.form ? Symplectic(x.form, x.data / y.data) : x.data / y.data
Base.:(\)(x::Symplectic, y::Symplectic) = x.form == y.form ? Symplectic(x.form, x.data \ y.data) : x.data \ y.data

"""
    issymplectic(form::Symplecticform, x::AbstractMatrix; atol=0.0, rtol=atol)
    issymplectic(x::Symplectic; atol=0.0, rtol=atol)

Return whether or not an input matrix is symplectic. Keyword arguments `atol` and `rtol`
can be called to determine absolute and relative tolerances of the check, respectively.
"""
function issymplectic(form::SymplecticForm, x::T; atol::R1 = 0, rtol::R2 = atol) where {T<:AbstractMatrix,R1<:Real,R2<:Real}
    omega = symplecticform(form)
    return isapprox(x * omega * x', omega; atol = atol, rtol = rtol)
end
function issymplectic(x::Symplectic; atol::R1 = 0, rtol::R2 = atol) where {R1<:Real,R2<:Real}
    omega = symplecticform(x.form)
    return isapprox(x.data * omega * x.data', omega; atol = atol, rtol = rtol)
end

"""
    randsymplectic(form::SymplecticForm)
    randsymplectic(::Symplectic, form::SymplecticForm)

Calculate a random symplectic matrix in symplectic representation defined by `basis`.
"""
randsymplectic(form::SymplecticForm{N}) where {N<:Int} = _randsymplectic(form)
randsymplectic(::Type{Symplectic}, form::SymplecticForm{N}) where {N<:Int} = Symplectic(form, _randsymplectic(form))
function _randsymplectic(form::PairForm{N}) where {N<:Int}
    n = form.n
    # random Block-Messiah/Euler decomposition
    O, O′ = _rand_orthogonal_symplectic(form), _rand_orthogonal_symplectic(form)
    rs = rand(n)
    D = Diagonal(collect(Iterators.flatten((i, 1/i) for i in rs)))
    return O * D * O′
end
function _randsymplectic(form::BlockForm{N}) where {N<:Int}
    n = form.n
    # random Block-Messiah/Euler decomposition
    O, O′ = _rand_orthogonal_symplectic(form), _rand_orthogonal_symplectic(form)
    rs = rand(n)
    D = Diagonal(vcat(rs, 1 ./ rs))
    return O * D * O′
end

# Generates random orthogonal symplectic matrix by blocking real
# and imaginary parts of a random unitary matrix
function _rand_orthogonal_symplectic(form::PairForm{N}) where {N<:Int}
    n = form.n
    U = _rand_unitary(form)
    O = zeros(2*n, 2*n)
    @inbounds for i in Base.OneTo(n), j in Base.OneTo(n)
        val = U[i,j]
        O[2*i-1, 2*j-1] = real(val)
        O[2*i, 2*j-1] = -imag(val)
        O[2*i-1, 2*j] = imag(val)
        O[2*i, 2*j] = real(val)
    end
    return O
end
function _rand_orthogonal_symplectic(form::BlockForm{N}) where {N<:Int}
    n = form.n
    U = _rand_unitary(form)
    O = zeros(2*n, 2*n)
    @inbounds for i in Base.OneTo(n), j in Base.OneTo(n)
        val = U[i,j]
        O[i, j] = real(val)
        O[i+n, j] = -imag(val)
        O[i, j+n] = imag(val)
        O[i+n, j+n] = real(val)
    end
    return O
end

# Generates unitary matrix randomly distributed over Haar measure;
# see https://arxiv.org/abs/math-ph/0609050 for algorithm.
# This approach is faster and creates less allocations than rand(Haar(2), n) from RandomMatrices.jl
function _rand_unitary(form::SymplecticForm{N}) where {N<:Int}
    n = form.n
    M = rand(ComplexF64, n, n) ./ sqrt(2.0)
    q, r = qr(M)
    d = Diagonal([r[i, i] / abs(r[i, i]) for i in Base.OneTo(n)])
    return q * d
end

"""
    BlochMessiah <: Factorization

Matrix factorization type of the Bloch-Messiah/Euler decomposition of a symplectic matrix `S`.
This is the return type of [`blochmessiah(_)`](@ref), the corresponding matrix factorization function.

If `F::BlochMessiah` is the factorization object, `O`, `values` and Q` can be obtained
via `F.O`, `F.values`, and `F.Q`.

Iterating the decomposition produces the components `O`, `values`, and `Q`, in that order.

# Examples
```
julia> S = Symplectic(BlockForm(1), [1. 1.; 0. 1.])
2×2 Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}:
 1.0  1.0
 0.0  1.0

julia> issymplectic(S)
true

julia> F = blochmessiah(S)
BlochMessiah{Float64, Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}, Vector{Float64}}
O factor:
2×2 Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}:
 0.850651  -0.525731
 0.525731   0.850651
values:
1-element Vector{Float64}:
 1.618033988749895
Q factor:
2×2 Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}:
  0.525731  0.850651
 -0.850651  0.525731

julia> isapprox(S, F.O * Diagonal(vcat(F.values, F.values .^ (-1))) * F.Q, atol = 1e-10)
true

julia> issymplectic(F.O, atol = 1e-10) && issymplectic(F.Q, atol = 1e-10)
true

julia> O, values, Q = F; # destructuring via iteration

julia> O == F.O && values == F.values && Q == F.Q
true
```
"""
struct BlochMessiah{T,M<:AbstractArray{T},N<:AbstractVector{T}} <: Factorization{T}
    O::M
    values::N
    Q::M
    function BlochMessiah{T,M,N}(O,values,Q) where {T,M<:AbstractArray{T},N<:AbstractVector{T}}
        require_one_based_indexing(O, values, Q)
        new{T,M,N}(O, values, Q)
    end
end
BlochMessiah{T}(O::AbstractArray{T}, values::AbstractVector{T}, Q::AbstractArray{T}) where {T} = BlochMessiah{T,typeof(O),typeof(values)}(O,values,Q)

# iteration for destructuring into components
Base.iterate(F::BlochMessiah) = (F.O, Val(:values))
Base.iterate(F::BlochMessiah, ::Val{:values}) = (F.values, Val(:Q))
Base.iterate(F::BlochMessiah, ::Val{:Q}) = (F.Q, Val(:done))
Base.iterate(F::BlochMessiah, ::Val{:done}) = nothing

"""
    blochmessiah(form::SymplecticForm, S::AbstractMatrix) -> BlochMessiah
    blochmessiah(S::Symplectic) -> BlochMessiah

Compute the Bloch-Messiah/Euler decomposition of a symplectic matrix `S` and return a `BlockMessiah` object.

The orthogonal symplectic matrices `O` and `Q` as well as the singular values `values` can be obtained
via `F.O`, `F.Q`, and `F.values`, respectively.

Iterating the decomposition produces the components `O`, `values`, and `Q`, in that order.

# Examples
```
julia> S = Symplectic(BlockForm(1), [1. 1.; 0. 1.])
2×2 Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}:
 1.0  1.0
 0.0  1.0

julia> issymplectic(S)
true

julia> F = blochmessiah(S)
BlochMessiah{Float64, Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}, Vector{Float64}}
O factor:
2×2 Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}:
 0.850651  -0.525731
 0.525731   0.850651
values:
1-element Vector{Float64}:
 1.618033988749895
Q factor:
2×2 Symplectic{BlockForm{Int64}, Float64, Matrix{Float64}}:
  0.525731  0.850651
 -0.850651  0.525731

julia> isapprox(S, F.O * Diagonal(vcat(F.values, F.values .^ (-1))) * F.Q, atol = 1e-10)
true

julia> issymplectic(F.O, atol = 1e-10) && issymplectic(F.Q, atol = 1e-10)
true

julia> O, values, Q = F; # destructuring via iteration

julia> O == F.O && values == F.values && Q == F.Q
true
```
"""
function blochmessiah(x::Symplectic{F,T,D}) where {F<:SymplecticForm,T,D<:AbstractMatrix{T}} 
    form = x.form
    O, values, Q = _blochmessiah(form, x.data)
    return BlochMessiah{T}(Symplectic(form, O), values, Symplectic(form, Q))
end
function blochmessiah(form::F, x::AbstractMatrix{T}) where {F<:SymplecticForm,T<:Real}
    O, values, Q = _blochmessiah(form, x)
    return BlochMessiah{T}(O, values, Q)
end
function _blochmessiah(form::BlockForm, x::AbstractMatrix{T}) where {T<:Real}
    O, P = polar(x)
    n = form.n
    vals, vecs = eigen(Symmetric(P), sortby = x -> isless(1.0, x) ? -1/x : 1/x)
    @inbounds for i in Base.OneTo(n)
        vecs[1, i] < 0.0 && (@view(vecs[:, i]) .*= -1.0)
        vecs[1, i+n] < 0.0 && (@view(vecs[:, i+n]) .*= -1.0)
    end
    O′ = O * vecs
    Q′ = vecs'
    values′ = vals[1:n]
    return BlochMessiah{T}(O′, values′, Q′)
end
function _blochmessiah(form::PairForm, x::AbstractMatrix{T}) where {T<:Real}
    O, P = polar(x)
    n = form.n
    vals, vecs = eigen(Symmetric(P), sortby = x -> isless(1.0, x) ? -1/x : 1/x)
    Q′ = P
    @inbounds for i in Base.OneTo(n)
        vecs[1, i] < 0.0 && (@view(vecs[:, i]) .*= -1.0)
        vecs[1, i+n] < 0.0 && (@view(vecs[:, i+n]) .*= -1.0)
        Q′[2i-1, :] .= @view(vecs[:, i])
        Q′[2i, :] .= @view(vecs[:, i+n])
    end
    O′ = O * Q′'
    values′ = vals[1:n]
    return BlochMessiah{T}(O′, values′, Q′)
end

function Base.show(io::IO, mime::MIME{Symbol("text/plain")}, F::BlochMessiah{<:Any,<:AbstractArray,<:AbstractVector})
    Base.summary(io, F); println(io)
    println(io, "O factor:")
    Base.show(io, mime, F.O)
    println(io, "\nvalues:")
    Base.show(io, mime, F.values)
    println(io, "\nQ factor:")
    Base.show(io, mime, F.Q)
end

"""
    SymplecticHouseholder <: AbstractMatrix

Matrix representation type of a symplectic Householder reflection on a symplectic basis.
This is the return type of [`householder(_)`](@ref), the corresponding reflection matrix function.

If `H::SymplecticHouseholder` is the reflection object, the mode `k` and projection matrix `P` can be obtained
via `H.k` and `H.P`.

# Examples
```jldoctest
julia> H = householder(BlockForm(3), 2, [0.23, 0.45])
6×6 SymplecticHouseholder{BlockForm{Int64}, Int64, Matrix{Float64}}:
 1.0    ⋅          ⋅         ⋅     ⋅          ⋅ 
  ⋅    0.585748  -0.810493   ⋅     ⋅          ⋅ 
  ⋅   -0.810493  -0.585748   ⋅     ⋅          ⋅ 
  ⋅     ⋅          ⋅        1.0    ⋅          ⋅ 
  ⋅     ⋅          ⋅         ⋅    0.585748  -0.810493
  ⋅     ⋅          ⋅         ⋅   -0.810493  -0.585748

julia> isapprox(H * H, I)
true
```
"""
struct SymplecticHouseholder{F<:SymplecticForm,N<:Int,T} <: AbstractMatrix{T}
    form::F
    k::N
    P::T
    SymplecticHouseholder(form::F, k::N, P::T) where {F<:SymplecticForm,N<:Int,T} = new{F,N,T}(form, k, P)
end
SymplecticHouseholder(x::SymplecticHouseholder) = x

"""
    householder(form::SymplecticForm, k::Int, v::AbstractVector) -> SymplecticHouseholder

Compute a symplectic Householder transformation of mode `k` and return a `SymplecticHouseholder` object.

The transformation uses a Householder reflector `P = I - 2vvᵀ / vᵀv` to act simultaneously on 
the leading and trailing blocks of the symplectic basis. Starting from index `k`, it reflects 
the corresponding sub-vectors in both halves of the space.
"""
function householder(form::SymplecticForm, k::Int, v::V) where {V}
    k < form.n || throw(ArgumentError("k must be less than n."))
    length(v) == (form.n - k + 1) || throw(ArgumentError("the length of v must be equal to n - k + 1"))
    vt = transpose(v)
    P = I - (2 / (vt * v)) * v * vt
    return SymplecticHouseholder(form, k, P)
end

function Base.Matrix(x::SymplecticHouseholder{F,N,T}) where {F<:BlockForm,N<:Int,T}
    n, k, P = (x.form).n, x.k, x.P
    M = Matrix{eltype(P)}(I, 2n, 2n)
    Base.copyto!(@view(M[k:n,k:n]), P)
    Base.copyto!(@view(M[n+k:2n,n+k:2n]), P)
    return M
end
function Base.Matrix(x::SymplecticHouseholder{F,N,T}) where {F<:PairForm,N<:Int,T}
    n, k, P = (x.form).n, x.k, x.P
    M = Matrix{eltype(P)}(I, 2n, 2n)
    @inbounds for i in Base.OneTo(n-k+1)
        @inbounds for j in Base.OneTo(n-k+1)
            M[2(i+k)-3, 2(j+k)-3] = P[i,j]
            M[2(i+k)-2, 2(j+k)-2] = P[i,j]
        end
    end
    return M
end
Base.Array(x::SymplecticHouseholder) = Matrix(x)
function Base.AbstractMatrix{T1}(x::SymplecticHouseholder{F,N,T2}) where {F<:BlockForm,N<:Int,T1,T2}
    n, k, P = (x.form).n, x.k, x.P
    M = Matrix{eltype(T1)}(I, 2n, 2n)
    Base.copyto!(@view(M[k:n,k:n]), P)
    Base.copyto!(@view(M[n+k:2n,n+k:2n]), P)
    return M
end
function Base.AbstractMatrix{T1}(x::SymplecticHouseholder{F,N,T2}) where {F<:PairForm,N<:Int,T1,T2}
    n, k, P = (x.form).n, x.k, x.P
    M = Matrix{eltype(P)}(I, 2n, 2n)
    @inbounds for i in Base.OneTo(n-k+1)
        @inbounds for j in Base.OneTo(n-k+1)
            M[2(i+k)-3, 2(j+k)-3] = P[i,j]
            M[2(i+k)-2, 2(j+k)-2] = P[i,j]
        end
    end
    return M
end

Base.checkbounds(x::SymplecticHouseholder, i::Int, j::Int) = (form = x.form; i <= 2 * form.n && j <= 2 * form.n)
Base.checkbounds(x::SymplecticHouseholder, i::Int) = (form = x.form; i <= (2 * form.n)^2)
Base.isequal(x::SymplecticHouseholder, y::SymplecticHouseholder) = x.form == y.form && x.k == y.k && x.P == y.P
Base.isapprox(x::SymplecticHouseholder, y::SymplecticHouseholder) = x.form == y.form && isapprox(x.k, y.k) && isapprox(x.P, y.P)
Base.size(x::SymplecticHouseholder) = (form = x.form; (2 * form.n, 2 * form.n))
Base.size(x::SymplecticHouseholder, dim::Int) = (form = x.form; 2 * form.n)
Base.length(x::SymplecticHouseholder) = prod(size(x))
Base.axes(x::SymplecticHouseholder) = (form = x.form; (Base.OneTo(2 * form.n), Base.OneTo(2 * form.n)))
Base.eltype(x::SymplecticHouseholder) = eltype(x.P)

Base.@propagate_inbounds function Base.getindex(x::SymplecticHouseholder{F,N,T}, i::Int, j::Int) where {F<:BlockForm,N<:Int,T}
    @boundscheck checkbounds(x, i, j)
    n, k, P = (x.form).n, x.k, x.P
    if i <= n && j <= n
        if i < k || j < k
            return i == j ? oneunit(eltype(P)) : zero(eltype(P))
        else
            return P[i - k + 1, j - k + 1]
        end
    elseif i > n && j > n
        if i < n + k || j < n + k
            return i == j ? oneunit(eltype(P)) : zero(eltype(P))
        else
            return P[i - n - k + 1, j - n - k + 1]
        end
    else
        return zero(eltype(P))
    end
end
Base.@propagate_inbounds function Base.getindex(x::SymplecticHouseholder{F,N,T}, i::Int, j::Int) where {F<:PairForm,N<:Int,T}
    @boundscheck checkbounds(x, i, j)
    n, k, P = (x.form).n, x.k, x.P
    if i < 2k-1
        if i == j
            return oneunit(eltype(P))
        else
            return zero(eltype(P))
        end
    elseif 2k-1 <= i && 2k-1 <= j
        if i % 2 == j % 2
            return P[cld(i,2) - k + 1, cld(j,2) - k + 1]
        else
            return zero(eltype(P))
        end
    else 
        return zero(eltype(P))
    end
end
Base.@propagate_inbounds function Base.getindex(x::SymplecticHouseholder, ind::Int)
    @boundscheck checkbounds(x, ind)
    n2 = 2 * x.form.n
    c, r = divrem(ind - 1, n2)
    return x[r + 1, c + 1]
end

LinearAlgebra.adjoint(x::SymplecticHouseholder) = x
LinearAlgebra.inv(x::SymplecticHouseholder) = x
Base.copy(x::SymplecticHouseholder) = SymplecticHouseholder(x.form, copy(x.k), copy(x.P))

@inline function Base.copyto!(dest::AbstractMatrix, src::SymplecticHouseholder{F,N,T}) where {F<:BlockForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(dest)
    size(dest, 1) == size(dest, 2) || throw(ArgumentError("cannot copy a SymplecticHouseholder object to a non-square matrix."))
    n, k, P = (src.form).n, src.k, src.P
    fill!(dest, zero(eltype(P)))
    @inbounds for i in axes(dest, 1)
        dest[i, i] = oneunit(eltype(P))
    end
    Base.copyto!(@view(dest[k:n, k:n]), P)
    Base.copyto!(@view(dest[n+k:2n, n+k:2n]), P)
    return dest
end
@inline function Base.copyto!(dest::Symplectic, src::SymplecticHouseholder{F,N,T}) where {F<:BlockForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(dest)
    @assert dest.form == src.form
    size(dest, 1) == size(dest, 2) || throw(ArgumentError("cannot copy a SymplecticHouseholder object to a non-square matrix."))
    n, k, P = (src.form).n, src.k, src.P
    fill!(dest, zero(eltype(P)))
    @inbounds for i in axes(dest, 1)
        dest[i, i] = oneunit(eltype(P))
    end
    Base.copyto!(@view(dest[k:n, k:n]), P)
    Base.copyto!(@view(dest[n+k:2n, n+k:2n]), P)
    return dest
end
@inline function Base.copyto!(dest::AbstractMatrix, src::SymplecticHouseholder{F,N,T}) where {F<:PairForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(dest)
    size(dest, 1) == size(dest, 2) || throw(ArgumentError("cannot copy a SymplecticHouseholder object to a non-square matrix."))
    n, k, P = (src.form).n, src.k, src.P
    fill!(dest, zero(eltype(P)))
    @inbounds for i in axes(dest, 1)
        dest[i, i] = oneunit(eltype(P))
    end
    @inbounds for i in Base.OneTo(n-k+1)
        @inbounds for j in Base.OneTo(n-k+1)
            dest[2(i+k)-3, 2(j+k)-3] = P[i,j]
            dest[2(i+k)-2, 2(j+k)-2] = P[i,j]
        end
    end
    return dest
end
@inline function Base.copyto!(dest::Symplectic, src::SymplecticHouseholder{F,N,T}) where {F<:PairForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(dest)
    @assert dest.form == src.form
    size(dest, 1) == size(dest, 2) || throw(ArgumentError("cannot copy a SymplecticHouseholder object to a non-square matrix."))
    n, k, P = (src.form).n, src.k, src.P
    fill!(dest, zero(eltype(P)))
    @inbounds for i in axes(dest, 1)
        dest[i, i] = oneunit(eltype(P))
    end
    @inbounds for i in Base.OneTo(n-k+1)
        @inbounds for j in Base.OneTo(n-k+1)
            dest[2(i+k)-3, 2(j+k)-3] = P[i,j]
            dest[2(i+k)-2, 2(j+k)-2] = P[i,j]
        end
    end
    return dest
end

@inline function LinearAlgebra.lmul!(H::SymplecticHouseholder{F,N,T}, A::AbstractMatrix) where {F<:BlockForm,N<:Int,T}
    n, k, P = H.form.n, H.k, H.P
    m = n - k + 1
    temp = Vector{eltype(A)}(undef, m)
    @inbounds for j in axes(A, 2)
        @inbounds for i in 1:m
            temp[i] = A[k + i - 1, j]
        end
        mul!(view(A, k:n, j), P, temp)
        @inbounds for i in 1:m
            temp[i] = A[n + k + i - 1, j]
        end
        mul!(view(A, n+k:2n, j), P, temp)
    end
    return A
end
@inline function LinearAlgebra.lmul!(x::SymplecticHouseholder{F,N,T}, y::AbstractVector) where {F<:BlockForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(y)
    n, k, P = x.form.n, x.k, x.P
    @views begin
        ytop = view(y, k:n)
        ybot = view(y, n+k:2n)
        mul!(ytop, P, ytop)
        mul!(ybot, P, ybot)
    end
    return y
end
@inline function LinearAlgebra.rmul!(A::AbstractMatrix, H::SymplecticHouseholder{F,N,T}) where {F<:BlockForm,N<:Int,T}
    n, k, P = H.form.n, H.k, H.P
    m = n - k + 1
    temp = Vector{eltype(A)}(undef, m)
    @inbounds for i in axes(A, 1)
        @inbounds for j in 1:m
            temp[j] = A[i, k + j - 1]
        end
        mul!(view(A, i, k:n), P', temp)
        
        @inbounds for j in 1:m
            temp[j] = A[i, n + k + j - 1]
        end
        mul!(view(A, i, n+k:2n), P', temp)
    end
    return A
end
@inline function LinearAlgebra.lmul!(H::SymplecticHouseholder{F,N,T}, Y::AbstractMatrix) where {F<:PairForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(Y)
    size(Y, 1) == size(Y, 2) || throw(ArgumentError("cannot compute the matrix product between a SymplecticHouseholder object and a non-square matrix."))
    n, k, P = H.form.n, H.k, H.P
    m = n - k + 1
    tempq = Vector{eltype(Y)}(undef, m)
    tempp = Vector{eltype(Y)}(undef, m)
    @inbounds for col in axes(Y, 2)
        @inbounds for j in 1:m
            tempq[j] = Y[2(j+k-1)-1, col]
            tempp[j] = Y[2(j+k-1), col]
        end
        @inbounds for i in 1:m
            tq, tp = zero(eltype(Y)), zero(eltype(Y))
            @inbounds for j in 1:m
                tq += P[i,j] * tempq[j]
                tp += P[i,j] * tempp[j]
            end
            Y[2(i+k-1)-1, col] = tq
            Y[2(i+k-1), col] = tp
        end
    end
    return Y
end
@inline function LinearAlgebra.lmul!(x::SymplecticHouseholder{F,N,T}, y::AbstractVector) where {F<:PairForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(y)
    n, k, P = x.form.n, x.k, x.P
    @inbounds for i in Base.OneTo(n-k+1)
        tq, tp = zero(eltype(y)), zero(eltype(y))
        for j in Base.OneTo(n - k + 1)
            tq += P[i,j] * y[2(j+k-1)-1]
            tp += P[i,j] * y[2(j+k-1)]
        end
        y[2(i+k-1)-1] = tq
        y[2(i+k-1)] = tp
    end
    return y
end
@inline function LinearAlgebra.rmul!(X::AbstractMatrix, H::SymplecticHouseholder{F,N,T}) where {F<:PairForm,N<:Int,T}
    LinearAlgebra.require_one_based_indexing(X)
    size(X, 1) == size(X, 2) || throw(ArgumentError("cannot compute the matrix product between a SymplecticHouseholder object and a non-square matrix."))
    n, k, P = H.form.n, H.k, H.P
    m = n - k + 1
    tempq = Vector{eltype(X)}(undef, m)
    tempp = Vector{eltype(X)}(undef, m)
    @inbounds for row in axes(X, 1)
        @inbounds for j in 1:m
            tempq[j] = X[row, 2(j+k-1)-1]
            tempp[j] = X[row, 2(j+k-1)]
        end
        @inbounds for i in 1:m
            tq, tp = zero(eltype(X)), zero(eltype(X))
            @inbounds for j in 1:m
                tq += tempq[j] * P[j,i]
                tp += tempp[j] * P[j,i]
            end
            X[row, 2(i+k-1)-1] = tq
            X[row, 2(i+k-1)] = tp
        end
    end
    return X
end
Base.:(*)(x::SymplecticHouseholder, y::SymplecticHouseholder) = x.k == y.k ? SymplecticHouseholder(x.form, x.k, x.P * y.P) : Symplectic(x.form, Matrix(x) * Matrix(y))
Base.:(*)(x::SymplecticHouseholder, y::Symplectic) = x.form == y.form ? Symplectic(x.form, x * y.data) : x * y.data
Base.:(*)(x::Symplectic, y::SymplecticHouseholder) = x.form == y.form ? Symplectic(x.form, x.data * y) : x.data * y
Base.:(/)(x::SymplecticHouseholder, y::SymplecticHouseholder) = x.k == y.k ? SymplecticHouseholder(x.form, x.k, x.P / y.P) : Symplectic(x.form, Matrix(x) / Matrix(y))
Base.:(/)(x::SymplecticHouseholder, y::Symplectic) = x.form == y.form ? Symplectic(x.form, x * inv(y.data)) : x * inv(y.data)
Base.:(/)(x::Symplectic, y::SymplecticHouseholder) = x.form == y.form ? Symplectic(x.form, x.data * inv(y)) : x.data * inv(y)
Base.:(/)(x::SymplecticHouseholder, y::AbstractMatrix) = x * inv(y)
Base.:(/)(x::AbstractMatrix, y::SymplecticHouseholder) = x * inv(y)
Base.:(\)(x::SymplecticHouseholder, y::SymplecticHouseholder) = x.k == y.k ? SymplecticHouseholder(x.form, x.k, x.P \ y.P) : Symplectic(x.form, Matrix(x) \ Matrix(y))
Base.:(\)(x::SymplecticHouseholder, y::Symplectic) = x.form == y.form ? Symplectic(x.form, inv(x) * y.data) : inv(x) * y.data
Base.:(\)(x::Symplectic, y::SymplecticHouseholder) = x.form == y.form ? Symplectic(x.form, inv(x.data) * y) : inv(x.data) * y
Base.:(\)(x::SymplecticHouseholder, y::AbstractMatrix) = inv(x) * y
Base.:(\)(x::AbstractMatrix, y::SymplecticHouseholder) = inv(x) * y

function Base.replace_in_print_matrix(x::SymplecticHouseholder{F,N,T}, i::Integer, j::Integer, s::AbstractString) where {F<:BlockForm,N<:Int,T}
    n, k = x.form.n, x.k
    in_upper_block = (k <= i <= n) && (k <= j <= n)
    in_lower_block = (n + k <= i <= 2n) && (n + k <= j <= 2n)
    is_diag = (i == j)
    if in_upper_block || in_lower_block || is_diag
        return s
    else
        return Base.replace_with_centered_mark(s)
    end
end
function Base.replace_in_print_matrix(x::SymplecticHouseholder{F,N,T}, i::Integer, j::Integer, s::AbstractString) where {F<:PairForm,N<:Int,T}
    n, k = x.form.n, x.k
    in_interleaved_block = (2k - 1 <= i <= 2n) && (2k - 1 <= j <= 2n) && (i % 2 == j % 2)
    is_diag = (i == j)
    if in_interleaved_block || is_diag
        return s
    else
        return Base.replace_with_centered_mark(s)
    end
end

using TestItemRunner
using SymplecticMatrices

# filter for the test
testfilter = ti -> begin
  exclude = Symbol[:jet]
  if !(VERSION >= v"1.10")
    push!(exclude, :doctests)
    push!(exclude, :aqua)                                 
  end

  return all(!in(exclude), ti.tags)
end

println("Starting tests with $(Threads.nthreads()) threads out of `Sys.CPU_THREADS = $(Sys.CPU_THREADS)`...")

@run_package_tests filter=testfilter

if get(ENV,"JET_TEST","")=="true"
    @run_package_tests filter=(ti -> :jet in ti.tags)
end

@testitem "householder" begin
    using SymplecticMatrices
    using LinearAlgebra: I, adjoint, inv, lmul!, rmul!

    @testset "predefined householder transformations" begin
        k, n = 2, 4
        v = [1.0, 2.0, 1.0]
        H_block, H_pair = householder(BlockForm(n), k, v), householder(PairForm(n), k, v)
        M_block = [1.  0.    0.   0. 0.  0.   0.   0.;
                   0.  2/3 -2/3 -1/3 0.  0.   0.   0.;
                   0. -2/3 -1/3 -2/3 0.  0.   0.   0.;
                   0. -1/3 -2/3  2/3 0.  0.   0.   0.;
                   0.  0.   0.   0.  1.  0.   0.   0.;
                   0.  0.   0.   0.  0.  2/3 -2/3 -1/3;
                   0.  0.   0.   0.  0. -2/3 -1/3 -2/3;
                   0.  0.   0.   0.  0. -1/3 -2/3  2/3]
        M_pair =  [1. 0.  0.    0.    0.   0.   0.   0.;
                   0. 1.  0.    0.    0.   0.   0.   0.;
                   0. 0.  2/3   0.   -2/3  0.  -1/3  0.;
                   0. 0.  0.    2/3   0.  -2/3  0.  -1/3;
                   0. 0. -2/3   0.   -1/3   0. -2/3  0.;
                   0. 0.  0.   -2/3   0.  -1/3  0.  -2/3;
                   0. 0. -1/3   0.   -2/3   0.  2/3  0.;
                   0. 0.  0.   -1/3   0.  -2/3   0.  2/3]
        @test M_block ≈ Matrix(H_block) && M_pair ≈ Matrix(H_pair)
        @test M_block ≈ Array(H_block) && M_pair ≈ Array(H_pair)
        @test AbstractMatrix{Float32}(M_block) ≈ AbstractMatrix{Float32}(H_block) && AbstractMatrix{Float32}(M_pair) ≈ AbstractMatrix{Float32}(H_pair)

        @test H_block[1,1] == H_block[5,5] == 1.0
        @test H_block[2,2] ≈ H_block[6,6] ≈ H_block[4,4] ≈ H_block[8,8] ≈ 2/3
        @test H_block[3,2] ≈ H_block[7,6] ≈ H_block[2,3] ≈ H_block[6,7] ≈ -2/3
        @test H_block[4,3] ≈ H_block[8,7] ≈ H_block[3,4] ≈ H_block[7,8] ≈ -2/3
        @test H_block[4,2] ≈ H_block[8,6] ≈ H_block[2,4] ≈ H_block[6,8] ≈ -1/3
        @test H_block[3,3] ≈ H_block[7,7] ≈ -1/3
        @test H_block[1,2] == H_block[2,1] == H_block[1,8] == H_block[8,1] == 0.0

        @test  H_pair[1,1] ==  H_pair[2,2] == 1.0
        @test  H_pair[3,3] ≈  H_pair[4,4] ≈  H_pair[7,7] ≈  H_pair[8,8] ≈ 2/3
        @test  H_pair[5,3] ≈  H_pair[4,6] ≈  H_pair[3,5] ≈  H_pair[6,4] ≈ -2/3
        @test  H_pair[5,7] ≈  H_pair[6,8] ≈  H_pair[7,5] ≈  H_pair[8,6] ≈ -2/3
        @test  H_pair[3,7] ≈  H_pair[4,8] ≈  H_pair[7,3] ≈  H_pair[8,4] ≈ -1/3
        @test  H_pair[5,5] ≈  H_pair[6,6] ≈ -1/3
        @test  H_pair[1,2] ==  H_pair[2,1] ==  H_pair[7,8] ==  H_pair[8,7] == 0.0
        @test  H_pair[2,3] ==  H_pair[3,2] ==  H_pair[3,4] ==  H_pair[4,3] == 0.0

        @test  H_block[1]  ==  H_block[37] == 1.0
        @test  H_block[10] ≈  H_block[28] ≈  H_block[46] ≈ H_block[64] ≈ 2/3
        @test  H_block[11] ≈  H_block[18] ≈  H_block[20] ≈ H_block[27] ≈ -2/3
        @test  H_block[47] ≈  H_block[54] ≈  H_block[56] ≈ H_block[63] ≈ -2/3
        @test  H_block[12] ≈  H_block[19] ≈  H_block[26] ≈ -1/3
        @test  H_block[48] ≈  H_block[55] ≈  H_block[62] ≈ -1/3
        @test  H_block[2]  ==  H_block[9]  ==  H_block[8]  == H_block[61] == 0.0

        @test   H_pair[1]  ==   H_pair[10] == 1.0
        @test   H_pair[19] ≈   H_pair[28] ≈   H_pair[55] ≈ H_pair[64] ≈ 2/3
        @test   H_pair[21] ≈   H_pair[30] ≈   H_pair[35] ≈ H_pair[39] ≈ -2/3
        @test   H_pair[44] ≈   H_pair[48] ≈   H_pair[53] ≈ H_pair[62] ≈ -2/3
        @test   H_pair[23] ≈   H_pair[32] ≈   H_pair[37] ≈ -1/3
        @test   H_pair[46] ≈   H_pair[51] ≈   H_pair[60] ≈ -1/3
        @test   H_pair[2]  ==   H_pair[9]  ==   H_pair[11] == H_pair[17] == 0.0
        @test   H_pair[20] ==   H_pair[22]  ==  H_pair[43] == H_pair[50] == 0.0

    end
    @testset "base methods" begin
        n = rand(3:5)
        k = rand(2:5)
        n = 2 * n
        v = rand(n-k+1)
        J, Omega = BlockForm(n), PairForm(n)
        M = rand(Float64, 2n, 2n)

        @inbounds for form in [J, Omega]
            H = householder(form, k, v)
            Hnew = householder(form, k-1, rand(n-k+2))
            @test isequal(H, copy(H)) && isapprox(H, copy(H))
            @test copy(H) ≈ H
            @test size(H) == (2n, 2n) && size(H, 1) == size(H, 2) == 2n
            @test length(H) == 4n^2
            @test axes(H) == (1:2n, 1:2n)
            @test eltype(H) == Float64

            HMat = Matrix(H)
            HMatnew = Matrix(Hnew)
            i, j = rand(1:2n), rand(1:2n)
            ind = rand(1:4n^2)
            @test H[i,j] ≈ HMat[i,j] && H[j,i] ≈ HMat[j,i]
            @test H[i] ≈ HMat[i] && H[j] ≈ HMat[j] && H[ind] ≈ HMat[ind]

            Z = zeros(Float64, 2n, 2n)
            SZ = Symplectic(form, copy(Z))
            copyto!(Z, H)
            copyto!(SZ, H)
            @test isapprox(Z, HMat, atol = 1e-8) && isapprox(SZ, Symplectic(form, HMat), atol = 1e-8)
            @test isapprox(H * M, HMat * M, atol = 1e-6) && isapprox(M * H, M * HMat, atol = 1e-8)
            @test isapprox(Matrix(H * H), HMat * HMat, atol = 1e-8) && isapprox(Symplectic(form, Matrix(Hnew * H)), Symplectic(form, HMatnew * HMat), atol = 1e-8)
            @test isapprox(H * Symplectic(form, M), Symplectic(form, HMat * M), atol = 1e-8) && isapprox(Symplectic(form, M) * H, Symplectic(form, M * HMat), atol = 1e-8)
            @test isapprox(H / M, HMat / M, atol = 1e-8) && isapprox(M / H, M / HMat, atol = 1e-8)
            @test isapprox(Matrix(H / H), HMat / HMat, atol = 1e-8) && isapprox(Symplectic(form, Matrix(Hnew / H)), Symplectic(form, HMatnew / HMat), atol = 1e-8)
            @test isapprox(H / Symplectic(form, M), Symplectic(form, HMat / M), atol = 1e-8) && isapprox(Symplectic(form, M) / H, Symplectic(form, M / HMat), atol = 1e-8)
            @test isapprox(H \ M, HMat \ M, atol = 1e-8) && isapprox(M \ H, M \ HMat, atol = 1e-8)
            @test isapprox(Matrix(H \ H), HMat \ HMat, atol = 1e-8) && isapprox(Symplectic(form, Matrix(Hnew \ H)), Symplectic(form, HMatnew \ HMat), atol = 1e-8)
            @test isapprox(H \ Symplectic(form, M), Symplectic(form, HMat \ M), atol = 1e-8) && isapprox(Symplectic(form, M) \ H, Symplectic(form, M \ HMat), atol = 1e-8)
        end
    end
    @testset "LinearAlgebra methods" begin
        n = rand(3:5)
        k = rand(2:n)
        n = 2 * n
        v = rand(n-k+1)
        J, Omega = BlockForm(n), PairForm(n)

        @inbounds for form in [J, Omega]
            H = householder(form, k, v)
            HMat = Matrix(H)
            @test Matrix(adjoint(H)) ≈ adjoint(Matrix(H))
            @test inv(H) ≈ H
        
            IR, IL = Matrix{Float64}(I, 2n, 2n), Matrix{Float64}(I, 2n, 2n)
            SIR, SIL = Symplectic(form, copy(IR)), Symplectic(form, copy(IL))
            lmul!(H, IL)
            rmul!(IR, H)
            lmul!(H, SIL)
            rmul!(SIR, H)
            @test isapprox(IL, HMat, atol = 1e-8) && isapprox(IR, HMat, atol = 1e-8)
            @test isapprox(SIL, Symplectic(form, HMat), atol = 1e-8) && isapprox(SIR, Symplectic(form, HMat))
        end
    end
end

@testitem "symplectic features" begin
    using SymplecticMatrices
    using SymplecticMatrices: _rand_orthogonal_symplectic, _rand_unitary
    using LinearAlgebra
    using Base: size, axes, eltype, getindex, setindex!, similar, Matrix, Array, AbstractMatrix, parent, copy, copyto!

    @testset "symplectic type" begin

        n = rand(1:5)
        J = BlockForm(n)
        Omega = PairForm(n)

        data_block = randsymplectic(J)
        data_pair = randsymplectic(Omega)

        S_block = Symplectic(J, data_block)
        S_pair = Symplectic(Omega, data_pair)

        @test randsymplectic(Symplectic, J) isa Symplectic && randsymplectic(Symplectic, Omega) isa Symplectic
        @test Symplectic(S_block) == S_block && Symplectic(S_pair) == S_pair
        @test eltype(S_block) == eltype(data_block) && eltype(S_pair) == eltype(data_pair)

        @test isequal(S_block, copy(S_block)) && isequal(S_pair, copy(S_pair))
        @test isapprox(S_block, copy(S_block)) && isapprox(S_pair, copy(S_pair))

        @test size(S_block) == size(data_block) && size(S_pair) == size(data_pair)
        @test size(S_block, 1) == size(data_block, 1) && size(S_pair, 1) == size(data_pair, 1)
        @test axes(S_block) == axes(data_block) && axes(S_pair) == axes(data_pair)
        @test S_block[n] == data_block[n] && S_pair[n] == data_pair[n]
        @test S_block[n, n] == data_block[n, n] && S_pair[n, n] == data_pair[n, n]
        @test setindex!(S_block, 0.0, n) == setindex!(data_block, 0.0, n) && setindex!(S_pair, 0.0, n) == setindex!(data_pair, 0.0, n)
        @test setindex!(S_block, 0.0, n, n) == setindex!(data_block, 0.0, n, n)
        @test setindex!(S_pair, 0.0, n, n) == setindex!(data_pair, 0.0, n, n)

        sim_S_block, sim_S_pair = similar(S_block), similar(S_pair)
        sim_S_block_float32, sim_S_pair_float32 = similar(S_block, Float32), similar(S_pair, Float32)
        sim_S_block_dim, sim_S_pair_dim = similar(S_block, (2,2)), similar(S_pair, (2,2))
        sim_S_block_dim_float32, sim_S_pair_dim_float32 = similar(S_block, Float32, (2,2)), similar(S_pair, Float32, (2,2))
        sim_S_block .= 0.0; sim_S_pair .= 0.0; sim_S_block_float32 .= 0.0; sim_S_pair_float32 .= 0.0;
        sim_S_block_dim .= 0.0; sim_S_pair_dim .= 0.0; sim_S_block_dim_float32 .= 0.0; sim_S_pair_dim_float32 .= 0.0;

        @test sim_S_block == Symplectic(J, sim_S_block.data) && sim_S_pair == Symplectic(Omega, sim_S_pair.data)
        @test sim_S_block_float32 == Symplectic(J, sim_S_block_float32.data) && sim_S_pair_float32 == Symplectic(Omega, sim_S_pair_float32.data)
        @test sim_S_block_dim == Symplectic(J, sim_S_block_dim.data) && sim_S_pair_dim == Symplectic(Omega, sim_S_pair_dim.data)
        @test sim_S_block_dim_float32 == Symplectic(J, sim_S_block_dim_float32.data) && sim_S_pair_dim_float32 == Symplectic(Omega, sim_S_pair_dim_float32.data)

        @test Matrix(S_block) == Matrix(data_block) && Matrix(S_pair) == Matrix(data_pair)
        @test Array(S_block) == Matrix(data_block) && Array(S_pair) == Matrix(data_pair)
        @test AbstractMatrix{Float32}(S_block) == Symplectic(J, AbstractMatrix{Float32}(data_block)) && AbstractMatrix{Float32}(S_pair) == Symplectic(Omega, AbstractMatrix{Float32}(data_pair))
        @test parent(S_block) == data_block && parent(S_pair) == data_pair

        zero_S_block, zero_S_pair = zero(S_block), zero(S_pair)
        @test copy(S_block) == S_block && copy(S_pair) == S_pair
        @test copyto!(copy(zero_S_block), S_block) == S_block && copyto!(copy(zero_S_pair), S_pair) == S_pair
        @test copyto!(copy(zero_S_block), data_block) == S_block && copyto!(copy(zero_S_pair), data_pair) == S_pair
        @test copyto!(zeros(2n, 2n), S_block) == data_block && copyto!(zeros(2n, 2n), S_pair) == data_pair
    end

    @testset "random objects" begin

        n = rand(1:5)
        J = BlockForm(n)
        Omega = PairForm(n)
        U_block = _rand_unitary(J)
        U_pair = _rand_unitary(Omega)
        @test isapprox(U_pair', inv(U_pair), atol = 1e-5)
        @test isapprox(U_block', inv(U_block), atol = 1e-5)

        O_block = _rand_orthogonal_symplectic(J)
        O_pair = _rand_orthogonal_symplectic(Omega)
        @test isapprox(O_pair', inv(O_pair), atol = 1e-5)
        @test isapprox(O_block', inv(O_block), atol = 1e-5)
        @test issymplectic(J, O_block, atol = 1e-5)
        @test issymplectic(Omega, O_pair, atol = 1e-5)

        S_block = randsymplectic(J)
        S_pair = randsymplectic(Omega)
        @test issymplectic(J, S_block, atol = 1e-5)
        @test issymplectic(Omega, S_pair, atol = 1e-5)

    end

    @testset "linear algebra" begin

        n = rand(1:5)
        J = BlockForm(n)
        Omega = PairForm(n)

        S_block = randsymplectic(Symplectic, J)
        S_pair = randsymplectic(Symplectic, Omega)

        data_block = S_block.data
        data_pair = S_pair.data

        for f in (:svd!, :lu!, :svdvals!, :lq!, :qr!, :eigvals!, :schur!, :eigen!, :hessenberg!)
            @test @eval(LinearAlgebra.$f)(copy(S_block)) == @eval(LinearAlgebra.$f)(copy(data_block))
            @test @eval(LinearAlgebra.$f)(copy(S_pair)) == @eval(LinearAlgebra.$f)(copy(data_pair))
        end
        for f in (:svd, :lu, :svdvals, :lq, :qr, :eigvals, :schur, :eigvecs, :eigen, :hessenberg)
            @test @eval(LinearAlgebra.$f)(S_block) == @eval(LinearAlgebra.$f)(data_block)
            @test @eval(LinearAlgebra.$f)(S_pair) == @eval(LinearAlgebra.$f)(data_pair)
        end
        for f in (:det, :tr, :pinv, :logdet)
            @test @eval(LinearAlgebra.$f)(S_block) == @eval(LinearAlgebra.$f)(data_block)
            @test @eval(LinearAlgebra.$f)(S_pair) == @eval(LinearAlgebra.$f)(data_pair)
        end
        @test isapprox(inv(S_block).data, inv(S_block.data), atol = 1e-5) && isapprox(inv(S_pair).data, inv(S_pair.data), atol = 1e-5)
        @test S_block * S_pair isa Matrix{Float64} && S_pair * S_block isa Matrix{Float64}
        @test issymplectic(S_block * S_block, atol = 1e-5) && issymplectic(S_pair * S_pair, atol = 1e-5)
        @test S_block / S_pair isa Matrix{Float64} && S_pair / S_block isa Matrix{Float64}
        @test issymplectic(S_block / S_block, atol = 1e-5) && issymplectic(S_pair / S_pair, atol = 1e-5)
        @test S_block \ S_pair isa Matrix{Float64} && S_pair \ S_block isa Matrix{Float64}
        @test issymplectic(S_block \ S_block, atol = 1e-5) && issymplectic(S_pair \ S_pair, atol = 1e-5)
        
        S1_block = randsymplectic(Symplectic, J)
        S1_pair = randsymplectic(Symplectic, Omega)
        mul!(S1_block, S_block, S_block)
        mul!(S1_pair, S_pair, S_pair)
        @test S1_block == S_block * S_block
        @test S1_pair == S_pair * S_pair
        mul!(S1_block, S_block, S_pair)
        mul!(S1_pair, S_pair, S_block)
        @test S1_block == S_block.data * S_pair.data && S1_pair == S_pair.data * S_block.data
    end
end

using Revise # for interactive work on docs
push!(LOAD_PATH,"../src/")

using Documenter
using DocumenterCitations
using SymplecticMatrices

DocMeta.setdocmeta!(SymplecticMatrices, :DocTestSetup, :(using SymplecticMatrices); recursive=true)

function main()
    #bib = CitationBibliography(joinpath(@__DIR__,"src/references.bib"), style=:authoryear)

    makedocs(
    #plugins=[bib],
    doctest = false,
    clean = true,
    sitename = "SymplecticMatrices.jl",
    format = Documenter.HTML(
        assets=["assets/init.js"],
        canonical = "https://apkille.github.io/SymplecticMatrices.jl"
    ),
    modules = [SymplecticMatrices],
    checkdocs = :exports,
    warnonly = false,
    authors = "Andrew Kille",
    pages = [
        "SymplecticMatrices.jl" => "index.md"
    ]
    )

    deploydocs(
        repo = "github.com/apkille/SymplecticMatrices.jl.git"
    )
end

main()

module SymplecticMatrices

import LinearAlgebra
import LinearAlgebra: givens
using LinearAlgebra: mul!, Diagonal, qr, Factorization, svd, require_one_based_indexing, Symmetric, eigen, eigen!, I, eigvals, adjoint, eigvecs, normalize!, AbstractRotation

export 
    # symplectic stuff
    Symplectic, issymplectic, symplecticform, BlockForm, PairForm, randsymplectic,
    # symplectic givens
    givens, SymplecticGivens,
    # symplectic householder
    householder, SymplecticHouseholder,
    # symplectic gauss
    gauss, SymplecticGauss,
    # polar decomposition
    polar, Polar,
    # takagi/autonne decomposition
    takagi, Takagi,
    # williamson decomposition
    williamson, Williamson,
    # bloch-messiah/euler decomposition
    blochmessiah, BlochMessiah

include("form.jl")

include("symplectic.jl")

include("givens.jl")

include("householder.jl")

include("gauss.jl")

include("polar.jl")

include("takagi.jl")

include("williamson.jl")

include("blochmessiah.jl")

end
